<?php

error_reporting(E_ALL);
ini_set('display_errors', '1');

Header("Access-Control-Allow-Origin: *");
Header("Access-Control-Allow-Credentials: true");
Header("Access-Control-Allow-Methods: GET,HEAD,OPTIONS,POST,PUT");
Header("Access-Control-Allow-Headers: access-control-expose-headers, Origin,Accept, X-Requested-With, Content-Type, Access-Control-Request-Method, Access-Control-Request-Headers");


date_default_timezone_set('America/Santiago');

$contentType = isset($_SERVER["CONTENT_TYPE"]) ? trim($_SERVER["CONTENT_TYPE"]) : '';

if ($contentType === "application/json") {
    //Receive the RAW post data.
    $content = trim(file_get_contents("php://input"));
    $decoded = json_decode($content, true);
    //If json_decode failed, the JSON is invalid.
    if (is_array($decoded)) {
        $input = $decoded['endpoint'];
        include_once 'apimetricas.php';
        $api = new Apimetricas();

        switch ($input) {
            case 0:
                break;
            case 1:
                $api->getAllVarOneStation($decoded['estacion']);
                break;
            case 2:
                $api->getVarOfStation($decoded['estacion']); //fecha,altura,caudal
                break;
            case 3:
                $api->getColumnsStation($decoded['estacion'], $decoded['columnas']);
                break;
            case 4:
                $api->getInfoStation($decoded['estacion']);
                break;
            case 5:
                $api->getOrgStations($decoded['organizacion']);
                break;
            case 6:
                $api->getOrgUsers($decoded['organizacion']);
                break;
            case 7:
                $api->getInfoUser($decoded['usuario']);
                break;
            case 8:
                break;
            case 9:
                break;
            case 10:
                $api->getInfoStationByDate($decoded['estacion'], $decoded['inicio'], $decoded['fin'], $decoded['from'], $decoded['limit']);
                break;
            case 10.1:
                $api->getInfoStationByDateClient($decoded['estacion'], $decoded['inicio'], $decoded['fin']);
                break;
            case 11:
                $api->getPromedioAcumulado($decoded['estacion']);
                //$api->getPromedioAcumulado($decoded['estacion'],$decoded['Tipo'],$decoded['A'],$decoded['B']);
                break;
            case 12:
                $api->getAllVarStations($decoded['estacion']);
                break;
            case 13:
                session_start();
                $_SESSION['view'] = $decoded['view'];
                echo json_encode(array('mensaje' => 'listo'));
                break;
            case 14:
                //session_start();
                $variable  = $decoded['variables'];
                foreach ($variable as $key => $value) {
                    $_SESSION[$key] = $value;
                }
                echo json_encode(array('mensaje' => 'listo'));
                break;
            case 15:
                session_start();
                $variable  = $decoded['variable'];
                echo json_encode(array('value' => $_SESSION[$variable]));
                break;
            case 16:
                $api->getLastData($decoded['estacion']);
                break;
            case 17:
                //informacioon de detalle de la esatcion
                $api->getInfoStationByDateDos($decoded['estacion'], $decoded['inicio'], $decoded['fin'], $decoded['from'], $decoded['limit']);
                break;
            case 18:
                $name= $api->makeFileToDownload($decoded['estacion'], $decoded['inicio'], $decoded['fin'], $decoded['email'], $decoded['stationdata']);
                $api->toEmail($name, $decoded['email'],$decoded['stationdata']['Nombre']);
                break;
            default:
                echo json_last_error();
                break;
        }
    } else {
        echo json_last_error();
    }
}
