<?php
session_start();
include_once 'metrica.php';
date_default_timezone_set('America/Santiago');
class Apimetricas
{
    public function getAllVarStations()
    {
        $metrica =  new Metrica();
        $metricas = array();
        $metricas["items"] = array();
        $res = $metrica->obtenerMetricas();


        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                $item = array(
                    'Fecha' => $row['date'],
                    'distmm' => $row['distmm'],
                    'timex2S' => $row['timex2S'],
                    'tempC' => $row['tempC'],
                    'Altura [cm]' => $row['altmm'],
                    'Estacion' => $row['station'],
                    'Caudal [L/s]' => $row['caudal'],
                    'acumulado' => $row['acumulado']
                );
                array_push($metricas['items'], $item);
            }

            echo json_encode($metricas);
        } else {
            echo json_encode(array('mensaje' => 'No hay elementos registrados'));
        }
    }

    public function getAllVarOneStation($estacion)
    {
        $metrica =  new Metrica();
        $metricas = array();
        $metricas["items"] = array();
        $res = $metrica->obtenerVarOneStation($estacion);


        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                $item = array(
                    'Fecha' => $row['date'],
                    'distmm' => $row['distmm'],
                    'timex2S' => $row['timex2S'],
                    'tempC' => $row['tempC'],
                    'Altura [cm]' => $row['altmm'],
                    'Estacion' => $row['station'],
                    'Caudal [L/s]' => $row['caudal'],
                    'acumulado' => $row['acumulado']
                );
                array_push($metricas['items'], $item);
            }

            echo json_encode($metricas);
        } else {
            echo json_encode(array('mensaje' => 'No hay elementos registrados'));
        }
    }

    public function getVarOfStation($estacion)
    {
        $metrica =  new Metrica();
        $metricas = array();
        $metricas["items"] = array();
        $res = $metrica->obtenerVarOfStations($estacion);


        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                $item = array(
                    'Fecha' => $row['date'],
                    'Altura [cm]' => $row['altmm'],
                    'Caudal [L/s]' => $row['caudal'],
                    'Pulsos' => $row['distmm']
                );
                array_push($metricas['items'], $item);
            }

            echo json_encode($metricas);
        } else {
            echo json_encode(array('mensaje' => 'No hay elementos registrados'));
        }
    }

    public function getInfoStation($estacion)
    {
        $metrica =  new Metrica();
        $metricas = array();
        $metricas["items"] = array();
        $res = $metrica->obtenerInfoStation($estacion);


        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                $item = array(
                    'Nombre' => $row['nombre'],
                    'Latitud' => $row['latitud'],
                    'Longitud' => $row['longitud'],
                    'Tipo' => $row['tipoestacionid'],
                    'A' => $row['A'],
                    'B' => $row['B'],
                    'Org' => $row['organizacion'],
                    'Tiempo' => $row['tiempo'],

                );
                array_push($metricas['items'], $item);
            }

            echo json_encode($metricas);
        } else {
            echo json_encode(array('mensaje' => 'No hay elementos registrados'));
        }
    }

    public function getColumnsStation($estacion, $columnas)
    {
        $metrica =  new Metrica();
        $metricas = array();
        $metricas["items"] = array();
        $columnas2 = "";
        if (is_array($columnas)) {
            foreach ($columnas as $valor) {
                $columnas2 = $columnas2 . $valor . ',';
            }
            $columnas2 = substr_replace($columnas2, '', strlen($columnas2) - 1);
        }

        $res = $metrica->obtenerColumnsStation($estacion, $columnas2);
        $cont = 0;
        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                $item = array();

                foreach ($columnas as $valor) {
                    array_push($item, $row[$valor]);
                }
                $item = array_combine($columnas, $item);
                array_push($metricas['items'], $item);
            }

            echo json_encode($metricas);
        } else {
            echo json_encode(array('mensaje' => 'No hay elementos registrados'));
        }
    }

    public function getInfoRecordStation($estacion)
    {
        $metrica =  new Metrica();
        $metricas = array();
        $metricas["items"] = array();
        $res = $metrica->obtenerVarOfStations($estacion);

        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                $item = array(
                    'Fecha' => $row['date'],
                    'Altura [cm]' => $row['altmm'],
                    'Caudal [L/s]' => $row['caudal']
                );
                array_push($metricas['items'], $item);
            }

            echo json_encode($metricas);
        } else {
            echo json_encode(array('mensaje' => 'No hay elementos registrados'));
        }
    }

    public function getInfoStationByDate2($estacion, $inicio, $fin)
    {
        $Station = new Apimetricas();
        $infoStation = $Station->getInfoStation2($estacion);
        $tipo = $infoStation['items'][0]['Tipo'];
        $A = $infoStation['items'][0]['A'];
        $B = $infoStation['items'][0]['B'];
        $Altura = 0;
        $caudal = 0;
        $Pulsos = 0;
        $volumen = 0;
        $unidad = 0;


        $metrica =  new Metrica();
        $metricas = array();
        $metricas["items"] = array();
        $res = $metrica->obtenerInfoStationByDate($estacion, $inicio, $fin);


        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                if ($tipo == 2) {
                    $Altura = $row['altmm'] / 1000;
                    $Pulsos = $row['distmm'];
                    $volumen = $A * $Pulsos;
                    // $caudal=$volumen/180;
                    $caudal = $row['flow'];
                    $unidad = "m";
                    
                    $item = array(
                    'Fecha' => $row['date'], // 'Altura ['.$unidad.']'=>$Altura,
                    'Altura' => number_format($Altura, 2, '.', ''),
                    'Caudal' => number_format($caudal, 2, '.', ''),
                    'accumulated' => number_format($row['accumulated'], 2, '.', ''),
                    'acday' => number_format($row['ac_day'], 2, '.', ''),
                    'acweek' => number_format($row['ac_week'], 2, '.', ''),
                    'acmonth' => number_format($row['ac_month'], 2, '.', ''),
                    'acyear' => number_format($row['ac_year'], 2, '.', ''),
                    'state' => $row['state'],

                );
                } else {
                    $Altura = $row['altmm'] / 10;
                    $caudal = $row['flow'];
                    $volumen = $caudal * 60;
                    $unidad = "cm";
                    
                    $item = array(
                    'Fecha' => $row['date'], // 'Altura ['.$unidad.']'=>$Altura,
                    'Altura' => number_format($Altura, 2, '.', ''),
                    'Caudal' => number_format($caudal, 2, '.', ''),
                    'Volumen' => number_format($row['volume'], 2, '.', ''),


                );
                    
                } 

                array_push($metricas['items'], $item);
            }

            echo json_encode($metricas);
        } else {
            echo json_encode(array('mensaje' => 'No hay elementos registrados'));
        }
    }

    public function getInfoStation2($estacion)
    {
        $metrica =  new Metrica();
        $metricas = array();
        $metricas["items"] = array();
        $res = $metrica->obtenerInfoStation($estacion);


        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                $item = array(
                    'Nombre' => $row['nombre'],
                    'Latitud' => $row['latitud'],
                    'Longitud' => $row['longitud'],
                    'Tipo' => $row['tipoestacionid'],
                    'A' => $row['A'],
                    'B' => $row['B'],
                    'Org' => $row['organizacion'],
                    'Tiempo' => $row['tiempo'],
                    'estado' => $row['estado'],
                    'nivel_corte' => $row['nivel_corte'],
                    'DGA_MEE' => $row['DGA_MEE'],
                    'codigoDeLaObra' => $row['codigoDeLaObra'],
                );
                array_push($metricas['items'], $item);
            }

            return $metricas;
        } else {
            return array('mensaje' => 'No hay elementos registrados');
        }
    }

    public function getVarOfStation2($estacion)
    {
        $Station = new Apimetricas();
        $infoStation = $Station->getInfoStation2($estacion);
        $tipo = $infoStation['items'][0]['Tipo'];
        $A = $infoStation['items'][0]['A'];
        $B = $infoStation['items'][0]['B'];
        $Altura = 0;
        $caudal = 0;
        $Pulsos = 0;
        $volumen = 0;
        $unidad = 0;

        $metrica =  new Metrica();
        $metricas = array();
        $metricas["items"] = array();
        $res = $metrica->obtenerVarOfStations($estacion);


        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                if ($tipo == 1) {
                    $Altura = $row['altmm'] / 10;
                    $caudal = $A * pow($Altura / 100, $B);
                    $volumen = $caudal * 180;
                    $unidad = "cm";
                } elseif ($tipo == 2) {
                    $Altura = $row['altmm'] / 1000;
                    $Pulsos = $row['distmm'];
                    $volumen = $A * $Pulsos;
                    $caudal = $volumen / 180;
                    // $caudal=$row['flow'];
                    $unidad = "m";
                }

                $item = array(
                    'Fecha' => $row['date'],
                    'Altura [' . $unidad . ']' => $Altura,
                    'Caudal [l/s]' => $caudal,
                    'Volumen [l]' => $volumen,
                );
                array_push($metricas['items'], $item);
            }

            echo json_encode($metricas);
        } else {
            echo json_encode(array('mensaje' => 'No hay elementos registrados'));
        }
    }

    public function getPromedioAcumulado2($estacion)
    {
        $Station = new Apimetricas();
        $infoStation = $Station->getInfoStation2($estacion);
        $tipo = $infoStation['items'][0]['Tipo'];
        $A = $infoStation['items'][0]['A'];
        $B = $infoStation['items'][0]['B'];
        $ktiempo = $infoStation['items'][0]['Tiempo'];
        $Ini = false;
        $fechaInicial = "";
        $fechaFinal = "";
        $fechaActual = new DateTime(date("Y-m-d H:i:s"));
        $semestreActual = 1;
        $añoActual = date("Y");
        $mesActual = date("Y-m");
        if (date("m") < 7) {
            $semestreActual = 1;
        } else {
            $semestreActual = 2;
        }
        $semanaActual = date("Y-W");
        $diaActual = date("Y-m-d");
        $semestreDato = 1;

        $altura = 0;
        $volumen = 0;
        $volumenTotal = 0;
        $caudal = 0;
        $Pulsos = 0;
        $totalDias = 0;
        $promedioDia = 0;
        $promedioSemana = 0;
        $promedioMes = 0;
        $promedioSemestre = 0;
        $promedioAño = 0;
        $AcumuladoDia = 0;
        $AcumuladoSemana = 0;
        $AcumuladoMes = 0;
        $AcumuladoSemestre = 0;
        $AcumuladoAño = 0;

        $metrica =  new Metrica();
        $metricas = array();
        $metricas["promedios"] = array();
        $metricas["Acumulados"] = array();
        $res = $metrica->obtenerPromedioAcumulado($estacion);


        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                if ($Ini == false) {
                    $Ini = true;
                    $fechaFinal = new DateTime($row['date']);
                }
                /////////////////Promedio////////////////////
                $Altura = $row['altmm'];

                if ($estacion == 20) {
                    $Altura = $row['distmm'];
                }


                if ($tipo == 1) {
                    $Altura =  $Altura / 10;
                    $caudal = $A * pow($Altura / 100, $B);
                    $volumen = $caudal * $ktiempo;
                    $volumenTotal += $volumen; // m3
                } elseif ($tipo == 2) {
                    // $Pulsos= $row['distmm'];
                    $volumen = $row['flow'] * $ktiempo;
                    // $volumen=$A*$Pulsos;
                    $volumenTotal += $volumen / 1000; // m3
                } elseif ($tipo == 3) {
                    $Altura =  $Altura / 10;
                    $caudal = $A * pow($Altura / 100, $B);
                    $volumen = $caudal * $ktiempo;
                    $volumenTotal += $volumen; // m3
                } elseif ($tipo == 4) {
                    $Altura =  $Altura / 1000;
                    $caudal = $A * pow($Altura / 1, $B);
                    $volumen = $caudal * $ktiempo;
                    $volumenTotal += $volumen; // m3
                }


                //////////////////Acumulado////////////////////////
                $fechaInicial = new DateTime($row['date']);
                $fechadedato = strtotime($row['date']);
                // $fechadedato = date_create_from_format('Y-m-d', $row['date']);

                if (date("m", $fechadedato) < 7) {
                    $semestreDato = 1;
                } else {
                    $semestreDato = 2;
                }
                // $diferencia = $fechaInicial->diff($fechaActual);
                // $dias=$diferencia->format('%a');

                if (date("Y-m-d", $fechadedato) == $diaActual) {
                    $AcumuladoDia = $volumenTotal;
                }
                if (date("Y-W", $fechadedato) == $semanaActual) {
                    $AcumuladoSemana = $volumenTotal;
                }
                if (date("Y-m", $fechadedato) == $mesActual) {
                    $AcumuladoMes = $volumenTotal;
                }
                if ($semestreDato == $semestreActual && date("Y", $fechadedato) == $añoActual) {
                    $AcumuladoSemestre = $volumenTotal;
                }
                if (date("Y", $fechadedato) == $añoActual) {
                    $AcumuladoAño = $volumenTotal;
                }
            }

            $difference = $fechaInicial->diff($fechaFinal);
            $totalDias = $difference->format('%a');

            $promedioDia = $volumenTotal / $totalDias;
            if ($totalDias < 29) {
                $promedioDia = 0;
            }

            if ($totalDias > 29) {
                $promedioSemana = $promedioDia * 7;
            }
            if ($totalDias > 29) {
                $promedioMes = $promedioDia * 30;
            }
            if ($totalDias > 181) {
                $promedioSemestre = $promedioDia * 182;
            }
            if ($totalDias > 364) {
                $promedioAño = $promedioDia * 365;
            }







            $itemPromedio = array(
                'totalDias' => $totalDias,
                'promedioDia' => $promedioDia,
                'promedioSemana' => $promedioSemana,
                'promedioMes' => $promedioMes,
                'promedioSemestre' => $promedioSemestre,
                'promedioAño' => $promedioAño
            );
            $itemAcumulado = array(
                'totalDias' => $totalDias,
                'AcumuladoDia' => $AcumuladoDia,
                'AcumuladoSemana' => $AcumuladoSemana,
                'AcumuladoMes' => $AcumuladoMes,
                'AcumuladoSemestre' => $AcumuladoSemestre,
                'AcumuladoAño' => $AcumuladoAño,
                'AcumuladoGlobal' => $volumenTotal
            );

            array_push($metricas['promedios'], $itemPromedio);
            array_push($metricas['Acumulados'], $itemAcumulado);

            return $metricas;
        } else {
            //    echo json_encode(array('mensaje' =>'No hay elementos registrados'));
        }
    }

    public function getPromedio($estacion)
    {
        $metrica = new Metrica();
        $promedio = $metrica->obtenerPromedio($estacion)->fetch(PDO::FETCH_ASSOC);

        if ($promedio == null) {
            return null;
        }

        $itemPromedio = array(
            'promedioDia' => round($promedio['diario'], 4),
            'promedioSemana' => round($promedio['semanal'], 4),
            'promedioMes' => round($promedio['mensual'], 3),
            'promedioSemestre' => round($promedio['semestral'], 2),
            'promedioAnual' => round($promedio['anual'], 2),
        );
        // echo print_r($itemPromedio);
        //    echo "<br><br>";
        return $itemPromedio;
    }

    public function getAcumulado($estacion)
    {
        $metrica = new Metrica();
        $acumulado = $metrica->obtenerAcumulado($estacion)->fetch(PDO::FETCH_ASSOC);

        if ($acumulado == null) {
            return null;
        }

        $itemAcumulado = array(
            'diario' => round($acumulado['diario'], 4),
            'semanal' => round($acumulado['semanal'], 4),
            'mensual' => round($acumulado['mensual'], 3),
            'semestral' => round($acumulado['semestral'], 2),
            'anual' => round($acumulado['anual'], 2),
            'global' => round($acumulado['anual'], 2),
        );
        // echo print_r($itemAcumulado);
        // echo "<br><br>";
        return $itemAcumulado;
    }

    public function calcPromedio($estacion)
    {
        ///Variables
        $promedioDia = 0;
        $promedioSemana = 0;
        $promedioMes = 0;
        $promedioSemestre = 0;
        $promedioAnual = 0;

        $metrica = new Metrica();
        $acumulado = $metrica->obtenerAcumulado($estacion)->fetch(PDO::FETCH_ASSOC);

        if ($acumulado == null) {
            // echo "Sin acumulado";
            // echo "<br><br>";
            return null;
        }

        $fechaInicial = $metrica->obtenerFirstDate($estacion)->fetch(PDO::FETCH_ASSOC);
        if ($fechaInicial == null || $fechaInicial['date'] == "0000-00-00 00:00:00") {
            // echo "Sin fechaInicial";
            // echo "<br><br>";
            return null;
        }
        $fechaFinal = $metrica->obtenerLastDate($estacion)->fetch(PDO::FETCH_ASSOC);
        if ($fechaFinal == null || $fechaFinal['date'] == "0000-00-00 00:00:00") {
            // echo "Sin fechaFinal";
            // echo "<br><br>";
            return null;
        }
        // echo "Estacion: " .json_encode($estacion);
        // echo "<br><br>";
        // echo "Fecha inicial: " .json_encode($fechaInicial['date']);
        // echo "<br><br>";
        // echo "Fecha final: ".json_encode($fechaFinal['date']);
        // echo "<br><br>";
        // echo "Acumulado: " . json_encode($acumulado['global']);
        // echo "<br><br>";

        $fIDt = new DateTime($fechaInicial['date']);
        $fFDt = new DateTime($fechaFinal['date']);

        $difference = $fIDt->diff($fFDt);
        $totalDias = $difference->format('%a');
        // echo "Total Dias: " . $totalDias;
        // echo "<br><br><br>";

        $acumladoGlobal = 0;
        $obj = new Metrica();
        $acumladoGlobal = $obj->obtenerAcumuladoGlobal($estacion)->fetchAll()['0']['volume'];
        $promedioDia = $acumladoGlobal / $totalDias;
        echo "Acumulado: " . json_encode($promedioDia);
        echo "<br><br>";
        if ($totalDias < 29) {
            $promedioDia = 0;
        }

        if ($totalDias > 29) {
            $promedioSemana = round($promedioDia * 7, 2);
        }

        if ($totalDias > 29) {
            $promedioMes = round($promedioDia * 30, 2);
        }

        if ($totalDias > 181) {
            $promedioSemestre = round($promedioDia * 182, 2);
        }

        if ($totalDias > 364) {
            $promedioAnual = round($promedioDia * 365, 2);
        }

        // $promedioDia=round($promedioDia,2);
        // $promedioSemana=round($promedioSemana,2);
        // $promedioMes=round($promedioMes,2);
        // $promedioSemestre=round($promedioSemestre,2);
        // $promedioAnual=round($promedioAnual,2);

        // echo $promedioDia;

        $itemPromedio = array(
            'totalDias' => $totalDias,
            'promedioDia' => round($promedioDia, 4),
            'promedioSemana' => round($promedioSemana, 4),
            'promedioMes' => round($promedioMes, 3),
            'promedioSemestre' => round($promedioSemestre, 2),
            'promedioAnual' => round($promedioAnual, 2),
        );

        // echo print_r($itemPromedio);
        // echo "<br><br>";
        return $itemPromedio;
    }

    public function getFirstDate($estacion)
    {
        $metrica = new Metrica();

        $fechaInicial = $metrica->obtenerFirstDate($estacion)->fetch(PDO::FETCH_ASSOC);
        if ($fechaInicial == null || $fechaInicial['date'] == "0000-00-00 00:00:00") {
            // echo "Sin fechaInicial";
            // echo "<br><br>";
            return null;
        }
        return $fechaInicial['date'];
    }

    public function getLastDate($estacion)
    {
        $metrica = new Metrica();

        $fechaFinal = $metrica->obtenerLastDate($estacion)->fetch(PDO::FETCH_ASSOC);
        if ($fechaFinal == null || $fechaFinal['date'] == "0000-00-00 00:00:00") {
            // echo "Sin fechaFinal";
            // echo "<br><br>";
            return null;
        }

        return $fechaFinal['date'];
    }

    public function calcAcumuladoByDate($estacion, $inicio, $fin)
    {
        $Station = new Apimetricas();
        $infoStation = $Station->getInfoStation2($estacion);
        $tipo = $infoStation['items'][0]['Tipo'];
        $A = $infoStation['items'][0]['A'];
        $B = $infoStation['items'][0]['B'];
        $ktiempo = $infoStation['items'][0]['Tiempo'];
        $Ini = false;
        $fechaInicial = "";
        $fechaFinal = "";
        $fechaActual = new DateTime(date("Y-m-d H:i:s"));
        $semestreActual = 1;
        $añoActual = date("Y");
        $mesActual = date("Y-m");
        if (date("m") < 7) {
            $semestreActual = 1;
        } else {
            $semestreActual = 2;
        }
        $semanaActual = date("Y-W");
        $diaActual = date("Y-m-d");
        $semestreDato = 1;
        $volumen = 0;
        $volumenTotal = 0;
        $caudal = 0;
        $totalDias = 0;
        $AcumuladoDia = 0;
        $AcumuladoSemana = 0;
        $AcumuladoMes = 0;
        $AcumuladoSemestre = 0;
        $AcumuladoAño = 0;

        $metrica =  new Metrica();

        $res = $metrica->obtenerInfoStationByDate($estacion, $inicio, $fin);


        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                if ($Ini == false) {
                    $Ini = true;
                    $fechaFinal = new DateTime($row['date']);
                }

                $Altura = $row['altmm'];

                if ($estacion == 20) {
                    $Altura = $row['distmm'];
                }


                if ($tipo == 1) {
                    $Altura =  $Altura / 10;
                    $caudal = $A * pow($Altura / 100, $B);
                    $volumen = $caudal * $ktiempo;
                    $volumenTotal += $volumen; // m3
                } elseif ($tipo == 2) {
                    // $Pulsos= $row['distmm'];
                    $volumen = $row['flow'] * $ktiempo;
                    // $volumen=$A*$Pulsos;
                    $volumenTotal += $volumen / 1000; // m3
                } elseif ($tipo == 3) {
                    $Altura =  $Altura / 10;
                    $caudal = $A * pow($Altura / 100, $B);
                    $volumen = $caudal * $ktiempo;
                    $volumenTotal += $volumen; // m3
                } elseif ($tipo == 4) {
                    $Altura =  $Altura / 1000;
                    $caudal = $A * pow($Altura / 1, $B);
                    $volumen = $caudal * $ktiempo;
                    $volumenTotal += $volumen; // m3
                }


                //////////////////Acumulado////////////////////////
                $fechaInicial = new DateTime($row['date']);
                $fechadedato = strtotime($row['date']);
                // $fechadedato = date_create_from_format('Y-m-d', $row['date']);

                if (date("m", $fechadedato) < 7) {
                    $semestreDato = 1;
                } else {
                    $semestreDato = 2;
                }
                // $diferencia = $fechaInicial->diff($fechaActual);
                // $dias=$diferencia->format('%a');

                if (date("Y-m-d", $fechadedato) == $diaActual) {
                    $AcumuladoDia = $volumenTotal;
                }
                if (date("Y-W", $fechadedato) == $semanaActual) {
                    $AcumuladoSemana = $volumenTotal;
                }
                if (date("Y-m", $fechadedato) == $mesActual) {
                    $AcumuladoMes = $volumenTotal;
                }
                if ($semestreDato == $semestreActual && date("Y", $fechadedato) == $añoActual) {
                    $AcumuladoSemestre = $volumenTotal;
                }
                if (date("Y", $fechadedato) == $añoActual) {
                    $AcumuladoAño = $volumenTotal;
                }
            }

            $itemAcumulado = array(
                'totalDias' => $totalDias,
                'diario' => $AcumuladoDia,
                'semanal' => $AcumuladoSemana,
                'mensual' => $AcumuladoMes,
                'semestral' => $AcumuladoSemestre,
                'anual' => $AcumuladoAño,
                'global' => $volumenTotal
            );

            return $itemAcumulado;
        } else {
            //    echo json_encode(array('mensaje' =>'No hay elementos registrados'));
        }
    }

    public function getVolumeCaudal($estacion, $altura, $pulsos)
    {
        $Station = new Apimetricas();
        $infoStation = $Station->getInfoStation2($estacion);

        $tipo = $infoStation['items'][0]['Tipo'];
        $A = $infoStation['items'][0]['A'];
        $B = $infoStation['items'][0]['B'];
        $ktiempo = $infoStation['items'][0]['Tiempo'];

        if ($ktiempo == 0) {
            $ktiempo = 180;
        }
        $caudal = 0;
        $volumen = 0;
        $volumenTotal = 0;

        $acumladoGlobal = 0;
        $obj = new Metrica();
        $acumladoGlobal = $obj->obtenerAcumuladoGlobal($estacion)->fetchAll()['0']['volume'];


        $metricas = array();
        $metricas["items"] = array();

        if ($estacion == 30) {
            $ktiempo = 60;
        }

        if ($tipo == 1) {
            $altura =  $altura / 10;
            $caudal = $A * pow($altura / 100, $B);
            $volumen = $caudal * $ktiempo;
        } elseif ($tipo == 2) {
            $volumen = $A * $pulsos;
            $caudal = $volumen / $ktiempo;
            $volumen = $volumen / 1000;
        } elseif ($tipo == 3) {
            $altura =  $altura / 10;
            $caudal = $A * pow($altura / 100, $B);
            $volumen = $caudal * $ktiempo;
        } elseif ($tipo == 4) {
            $altura =  $altura / 1000;
            $caudal = $A * pow($altura / 1, $B);
            $volumen = $caudal * $ktiempo;
        }

        $item = array(
            'caudal' => $caudal,
            'volumen' => $volumen,
            'acu_global' => $acumladoGlobal,
        );

        array_push($metricas['items'], $item);
        return $metricas;
    }

    public function getInfoStationByDate($estacion, $inicio, $fin, $from, $limit)
    {
        $metrica =  new Metrica();
        $res = $metrica->obtenerInfoStationByDatePrueba($estacion, $inicio, $fin, $from, $limit);
        $res2 = $metrica->obtenerInfoStationByDateDosPrueba($estacion, $inicio, $fin, $from, $limit);

        if ($res && $res2) {
            $results = $res->fetchAll(PDO::FETCH_ASSOC);
            $results2 = $res2->fetchAll(PDO::FETCH_ASSOC);
            $results3 = array_merge($results, [$results2]);
            echo json_encode($results3);
        } else {
            echo json_encode(array('mensaje' => 'No hay elementos registrados'));
        }
    }

    public function getInfoStationByDateClient($estacion, $inicio, $fin)
    {
        $metrica =  new Metrica();
        $metricas = array();
        $metricas["items"] = array();
        $res = $metrica->obtenerInfoStationByDate($estacion, $inicio, $fin);


        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                $item = array(
                    'Fecha' => $row['date'],
                    'Altura [cm]' => $row['altmm'],
                    'Caudal [L/s]' => $row['flow'],
                    'Pulsos' => $row['distmm'],
                    'timex2S' => $row['timex2S'],
                    'Acumulado' => $row['accumulated']
                );
                array_push($metricas['items'], $item);
            }

            echo json_encode($metricas);
        } else {
            echo json_encode(array('mensaje' => 'No hay elementos registrados'));
        }
    }

    public function getInfoStationByDateDos($estacion, $inicio, $fin, $from, $limit)
    {
        $metrica =  new Metrica();
        $res = $metrica->obtenerInfoStationByDatePrueba($estacion, $inicio, $fin, $from, $limit);
        $res2 = $metrica->obtenerInfoStationByDateDosPrueba($estacion, $inicio, $fin, $from, $limit);
        if ($res && $res2) {
            $results = $res->fetchAll(PDO::FETCH_ASSOC);
            $results2 = $res2->fetchAll(PDO::FETCH_ASSOC);
            $results3 = array_merge($results, [$results2]);
            echo json_encode($results3);
        } else {
            echo json_encode(array('mensaje' => 'No hay elementos registrados'));
        }
    }

    public function getPromedioAcumuladoObsoleto($estacion, $tipo, $A, $B)
    {
        $Ini = false;
        $fechaInicial = "";
        $fechaFinal = "";
        $fechaActual = new DateTime(date("Y-m-d H:i:s"));
        $semestreActual = 1;
        $añoActual = date("Y");
        $mesActual = date("Y-m");
        if (date("m") < 7) {
            $semestreActual = 1;
        } else {
            $semestreActual = 2;
        }
        $semanaActual = date("Y-W");
        $diaActual = date("Y-m-d");
        $semestreDato = 1;

        $altura = 0;
        $volumen = 0;
        $volumenTotal = 0;
        $caudal = 0;
        $Pulsos = 0;
        $totalDias = 0;
        $promedioDia = 0;
        $promedioSemana = 0;
        $promedioMes = 0;
        $promedioSemestre = 0;
        $promedioAño = 0;
        $AcumuladoDia = 0;
        $AcumuladoSemana = 0;
        $AcumuladoMes = 0;
        $AcumuladoSemestre = 0;
        $AcumuladoAño = 0;

        $metrica =  new Metrica();
        $metricas = array();
        $metricas["promedios"] = array();
        $metricas["Acumulados"] = array();
        $res = $metrica->obtenerPromedioAcumulado($estacion);


        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                if ($Ini == false) {
                    $Ini = true;
                    $fechaFinal = new DateTime($row['date']);
                }
                /////////////////Promedio////////////////////
                if ($tipo == 1) {
                    $Altura = $row['altmm'] / 10;
                    $caudal = $A * pow($Altura / 100, $B);
                    $volumen = $caudal * 180;
                    $volumenTotal += $volumen; // m3
                } elseif ($tipo == 2) {
                    $Pulsos = $row['distmm'];
                    $volumen = $A * $Pulsos;
                    $volumenTotal += $volumen / 1000; // m3
                }
                //////////////////Acumulado////////////////////////
                $fechaInicial = new DateTime($row['date']);
                $fechadedato = strtotime($row['date']);
                // $fechadedato = date_create_from_format('Y-m-d', $row['date']);

                if (date("m", $fechadedato) < 7) {
                    $semestreDato = 1;
                } else {
                    $semestreDato = 2;
                }
                // $diferencia = $fechaInicial->diff($fechaActual);
                // $dias=$diferencia->format('%a');

                if (date("Y-m-d", $fechadedato) == $diaActual) {
                    $AcumuladoDia = $volumenTotal;
                }
                if (date("Y-W", $fechadedato) == $semanaActual) {
                    $AcumuladoSemana = $volumenTotal;
                }
                if (date("Y-m", $fechadedato) == $mesActual) {
                    $AcumuladoMes = $volumenTotal;
                }
                if ($semestreDato == $semestreActual && date("Y", $fechadedato) == $añoActual) {
                    $AcumuladoSemestre = $volumenTotal;
                }
                if (date("Y", $fechadedato) == $añoActual) {
                    $AcumuladoAño = $volumenTotal;
                }
            }

            $difference = $fechaInicial->diff($fechaFinal);
            $totalDias = $difference->format('%a');

            $promedioDia = $volumenTotal / $totalDias;

            if ($totalDias > 6) {
                $promedioSemana = $promedioDia * 7;
            }
            if ($totalDias > 29) {
                $promedioMes = $promedioDia * 30;
            }
            if ($totalDias > 181) {
                $promedioSemestre = $promedioDia * 182;
            }
            if ($totalDias > 364) {
                $promedioAño = $promedioDia * 365;
            }







            $itemPromedio = array(
                'totalDias' => $totalDias,
                'promedioDia' => $promedioDia,
                'promedioSemana' => $promedioSemana,
                'promedioMes' => $promedioMes,
                'promedioSemestre' => $promedioSemestre,
                'promedioAño' => $promedioAño
            );
            $itemAcumulado = array(
                'totalDias' => $totalDias,
                'AcumuladoDia' => $AcumuladoDia,
                'AcumuladoSemana' => $AcumuladoSemana,
                'AcumuladoMes' => $AcumuladoMes,
                'AcumuladoSemestre' => $AcumuladoSemestre,
                'AcumuladoAño' => $AcumuladoAño
            );

            array_push($metricas['promedios'], $itemPromedio);
            array_push($metricas['Acumulados'], $itemAcumulado);

            echo json_encode($metricas);
        } else {
            echo json_encode(array('mensaje' => 'No hay elementos registrados'));
        }
    }

    public function getOrgStations($organizacion)
    {
        $metrica =  new Metrica();
        $metricas = array();
        $metricas["items"] = array();
        $res = $metrica->obtenerOrgStations($organizacion);

        
        //connection to DB
        
        $host='localhost';
        $username='wwhidr_hidrobytes';
        $user_pass='&mj&U5okRNOZ';
        $database_in_use='wwhidr_monitoreohidrico';
        $con = mysqli_connect($host,$username,$user_pass,$database_in_use);

/*      $host='localhost';
        $username='anomozco_ayonSettings';
        $user_pass='ayonSettings';
        $database_in_use='anomozco_ayonSettings';
        $con = mysqli_connect($host,$username,$user_pass,$database_in_use);
*/
        //the person who is logged in, we extract its organization locations
        //so now we add an additional check that we should display only those location which are assigned to it
        //fetching user deets
        $userEmail=$_SESSION['user'];
        $query="select * from usuarios where email='$userEmail'";
        $result=$con->query($query);
        while($row=$result->fetch_assoc()){
            $role=$row['perfil'];
            $userId=$row['usuarioid'];
        }
        if($role!="admin"){
            //if not admin then extract the ids of the locations that is assigned to this person
            $query="select * from assigned_stations where userId='$userId'";
            $result=$con->query($query);
            $assignedStations=[];
            while($row=$result->fetch_assoc()){
                array_push($assignedStations,$row['stationId']);
            }
        }
        
        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                if(($role!="admin") && (!in_array($row['idest'],$assignedStations)))//if not admin and this is not an assigned station then do not insert this station
                    continue;
                $item = array(
                    'Id' => $row['idest'],
                    'Nombre' => $row['nombre'],
                    'Latitud' => $row['latitud'],
                    'Longitud' => $row['longitud'],
                    'Tipo' => $row['tipoestacionid'],
                    'A' => $row['A'],
                    'B' => $row['B'],
                    'Parametros' => $row['parametros'],
                    'Org' => $row['organizacion']
                );
                array_push($metricas['items'], $item);
                
            }

            echo json_encode($metricas);
        } else {
            echo json_encode(array('mensaje' => 'No hay elementos registrados'));
        }
    }

    public function getOrgUsers($organizacion)
    {
        $metrica =  new Metrica();
        $metricas = array();
        $metricas["items"] = array();
        $res = $metrica->obtenerOrgUsers($organizacion);


        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                $item = array(
                    'Nombre' => $row['nombre'],
                    'activo' => $row['activo'],
                    'email' => $row['email'],
                    'organizacion' => $row['organizacionUser'],
                    'perfil' => $row['perfil']

                );
                array_push($metricas['items'], $item);
            }

            echo json_encode($metricas);
        } else {
            echo json_encode(array('mensaje' => 'No hay elementos registrados'));
        }
    }

    public function getInfoUser($user)
    {
        $metrica =  new Metrica();
        $metricas = array();
        $metricas["items"] = array();
        $res = $metrica->obtenerInfoUser($user);


        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                $item = array(
                    'Nombre' => $row['nombre'],
                    'activo' => $row['activo'],
                    'email' => $row['email'],
                    'organizacion' => $row['organizacionUser'],
                    'perfil' => $row['perfil']
                );
                array_push($metricas['items'], $item);
            }

            echo json_encode($metricas);
        } else {
            echo json_encode(array('mensaje' => 'No hay elementos registrados'));
        }
    }

    public function getInfoUser2($user)
    {
        $metrica =  new Metrica();
        $metricas = array();
        $metricas["items"] = array();
        $res = $metrica->obtenerInfoUser($user);


        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                $item = array(
                    'id' => $row['usuarioid'],
                    'Nombre' => $row['nombre'],
                    'activo' => $row['activo'],
                    'email' => $row['email'],
                    'organizacion' => $row['organizacionUser'],
                    'perfil' => $row['perfil']
                );
                array_push($metricas['items'], $item);
            }

            return json_encode($metricas);
        } else {
            return json_encode(array('mensaje' => 'No hay elementos registrados'));
        }
    }

    public function getPromedioAcumulado($estacion)
    {
        $metrica =  new Metrica();
        $metricas = array();
        $metricas["promedios"] = array();
        $metricas["Acumulados"] = array();
        ///////////////////////////////////////////////////////////////
        $res = $metrica->obtenerPromedio($estacion);
        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                $itemPromedio = array(
                    'promedioDia' => $row['diario'],
                    'promedioSemana' => $row['semanal'],
                    'promedioMes' => $row['mensual'],
                    'promedioSemestre' => $row['semestral'],
                    'promedioAño' => $row['anual'],
                );
                array_push($metricas['promedios'], $itemPromedio);
            }
        } else {
            echo json_encode(array('mensaje' => 'No hay elementos registrados'));
        }

        ///////////////////////////////////////////////////////////////
        $res = $metrica->obtenerAcumulado($estacion);
        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                $itemAcumulado = array(
                    'AcumuladoDia' => $row['ac_day'],
                    'AcumuladoSemana' => $row['ac_week'],
                    'AcumuladoMes' => $row['ac_month'],
                    'AcumuladoSemestre' => $row['ac_month'],
                    'AcumuladoAño' => $row['ac_year'],
                );
                array_push($metricas['Acumulados'], $itemAcumulado);
            }
            echo json_encode($metricas);
        } else {
            echo json_encode(array('mensaje' => 'No hay elementos registrados'));
        }
    }

    public function Tz1_To_Tz2($time, $fromTz, $toTz, $format)
    {
        // timezone by php friendly values
        if ($time == "") {
            return "";
        }
        $date = new DateTime($time, new DateTimeZone($fromTz));
        $date->setTimezone(new DateTimeZone($toTz));
        $time = $date->format($format);
        return $time;
    }

    public function getStationTz($estacion)
    {
        $metrica =  new Metrica();
        $metricas = array();
        $metricas["items"] = array();
        $res = $metrica->obtenerInfoStation($estacion);


        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                $item = array(
                    'TimeFrom' => $row['TimeZoneFrom'],
                    'TimeTo' => $row['TimeZoneTo'],

                );
                array_push($metricas['items'], $item);
            }

            return json_encode($metricas);
        } else {
            return json_encode(array('mensaje' => 'No hay elementos registrados'));
        }
    }

    public function getLastData($estacion)
    {
        $metrica =  new Metrica();

        $res = $metrica->obtenerLastDataStation($estacion);
        if ($res->rowCount()) {
            echo json_encode($res->fetch(PDO::FETCH_ASSOC));
        } else {
            echo json_encode(array('mensaje' => 'No hay elementos registrados'));
        }
    }

    public function diffMinutes($datetime1_, $datetime2_)
    {
        $datetime1 = date_create($datetime1_);
        $datetime2 = date_create($datetime2_);
        $interval = date_diff($datetime1, $datetime2);

        $days = $interval->format('%R%a');
        $hour = $interval->format('%R%H');
        $min = $interval->format('%R%I');
        $sec = $interval->format('%R%S');

        $min += $days * 24 * 60;
        $min += $hour * 60;
        $min += $sec / 60;


        return $min;
    }

    public function makeFileToDownload($estacion, $inicio, $fin, $email, $stationdata)
    {

        $nameStation=str_replace("°", "_", $stationdata['Nombre']);
        $nameStation=str_replace(" ", "", $nameStation);
        $nameStation=$this->eliminar_acentos($nameStation);
        $typeEstacion = $stationdata["Tipo"];
        $timestamp = time();
        // $filename = 'Estacion_' . date('YmdGis') . $timestamp . '.xls';
        $filename = 'Estacion_' .$nameStation.'_'.$timestamp . '.xls';
        $filepath = "../downloads/" . $filename;
        $metrica =  new Metrica();
        $res = $metrica->obtenerInfoStationByDataToExcel($estacion, $inicio, $fin);
        $table = "";
        $table .= "<table>";
        $results = $res->fetchAll(PDO::FETCH_OBJ);

        switch ($typeEstacion) {
            case 1:
                $table .= "<thead> <th>Fecha</th> <th>Altura [cm]</th><th>Caudal [L/s]</th></thead>";
                foreach ($results as $r) {
                    $flow = $r->flow;
                    if ($flow <= 0) {
                        $flow = ($stationdata["A"] * pow(($r->altmm / 100), $stationdata["B"])) * 1000; //para caudal altura debe ser en m, y la salida es metros cubicos por segundos
                    }
                    $table .= "<tr><td>" . $r->date . "</td><td>" . number_format(($r->altmm) / 10, 2, ',', '') . "</td><td>" . number_format(($flow), 2, ',', '') . "</td></tr>";
                }
                break;
            case 2:
                $table .= "<thead> <th>Fecha</th> <th>Nivel Freatico [m]</th><th>Caudal [L/s]</th></th><th>Acumulado [m3]</th></thead>";
                foreach ($results as $r) {
                    $table .= "<tr><td>" . $r->date . "</td><td>" . number_format(($r->altmm) / 1000, 2, ',', '') . "</td><td>" . number_format(($r->flow), 2, ',', '') . "</td><td>" . number_format(($r->accumulated), 1, ',', '') . "</td></tr>";
                }
                break;
            case 3:
                $table .= "<thead> <th>Fecha</th> <th>Altura de compuerta [cm]</th><th>Caudal [L/s]</th></thead>";
                foreach ($results as $r) {
                    $flow = $r->flow;
                    if ($flow <= 0) {
                        $flow = ($stationdata["A"] * pow(($r->altmm / 100), $stationdata["B"])) * 1000; //para caudal altura debe ser en m, y la salida es metros cubicos por segundos
                    }
                    $table .= "<tr><td>" . $r->date . "</td><td>" .  number_format(($r->altmm) / 10, 2, ',', '') . "</td><td>" . number_format(($flow), 2, ',', '') . "</td></tr>";
                }
                break;
            case 4:
                $table .= "<thead> <th>Fecha</th> <th>Altura de agua [m]</th><th>Volumen [m3]</th></thead>";
                foreach ($results as $r) {
                    $flow = $r->flow;
                    if ($flow <= 0) {
                        $flow = ($stationdata["A"] * pow(($r->altmm / 100), $stationdata["B"])) * 1000; //para caudal altura debe ser en m, y la salida es metros cubicos por segundos
                    }
                    $table .= "<tr><td>" . $r->date . "</td><td>" . number_format(($r->altmm) / 1000, 2, ',', '') . "</td><td>" . number_format(($flow), 2, ',', '') . "</td></tr>";
                }
                break;
        }

        $table .= "</table>";

        file_put_contents($filepath, $table);

        return $filename;
    }

    public function toEmail($name, $email,$estacionName)
    {

        $estacionName=str_replace("°", "_", $estacionName);

        $to = $email;
        //sender
        $from = 'Descargas HidroBytes <info@monitoreohidrico.cl>';
        $fromName = 'Descargas HidroBytes';
        //email subject
        $subject = 'Link de descarga datos estacion '.$estacionName;

        $link = 'https://www.monitoreohidrico.cl/Website/api/downloads.php?id=' . $name;
        $htmlContent = $this->templateToEmail($estacionName,$link);;

        $mime_boundary = md5("monitoreo");
        //headers for attachment
        $headers = "MIME-Version: 1.0\r\n";
        $headers .= "From:" .  $from . "\r\n";
        $headers .= "Replay-To: " . $from . " 1.0" . "\r\n";
        $headers .= "Content-Type: multipart/mixed; boundary = $mime_boundary\r\n\r\n";
        //multipart boundary
        $message = "--$mime_boundary\r\n";
        $message .= "Content-Type: text/html; charset=ISO-8859-1\r\n";
        $message .= "Content-Transfer-Encoding: base64\r\n\r\n";
        $message .= chunk_split(base64_encode('' . $htmlContent));

        $returnpath = "-f" . $from;
        //send email
        $mail = @mail($to, $subject, $message, $headers, $returnpath);
    
        echo json_encode($mail ? "Email Sent Successfully!" : "Email sending failed.");
    
    }

    function templateToEmail($nameStation,$link)
    {

        $htmlContent ='<!DOCTYPE html>
        <html lang="en">
        <head>
            <meta charset="UTF-8">
            <meta http-equiv="X-UA-Compatible" content="IE=edge">
            <meta name="viewport" content="width=device-width, initial-scale=1.0">
            <title>Email</title>
            <style>
            .container_email{
                background-color: rgb(128, 24, 247);
                background-repeat: no-repeat;
                background-size: cover;
                max-width: 600px;
                height: auto;
                border-radius: 4px;
                padding: 20px;
                display: flex;
                justify-content: center;
                align-items: center;
                }
        
        
            .email{
            border-radius: 8px;
            padding: 10px;
            background-color: rgb(255, 255, 255);
            max-width: 80vw;
            color: rgb(80, 78, 78);
            flex-direction: column;
            font-family: "Lucida Sans", "Lucida Sans Regular", "Lucida Grande", "Lucida Sans Unicode", Geneva, Verdana, sans-serif;
            }
            .container_link{
            display: flex;
            justify-content: center;
            align-items: center;
            }
            .link{
            border-radius: 8px;
            padding: 10px;
            background-color: rgb(49, 52, 199);
            max-width: 350px;
            display: flex;
            justify-content: center;
            align-items: center;
            }
            .link > a{
                color: antiquewhite;
                text-decoration: none;
            }
            .link:hover{
                background-color: rgb(16, 155, 25);
                color: rgb(255, 255, 255);
                font-weight: bold;
                text-decoration: none;
            }
            </style>
        </head>
        <body>
            <div class="container_email">
                <div class="email">
                    <h2>Link de descarga de datos de la Estacion '.$nameStation.'</h2>
                    <h4>Puede usar presionar el siguiente boton para descargar su archivo</h4>
                    <div class="container_link">
                        <div class="link">
                            <a href="'.$link.'">
                                Descargar Archivo
                            </a>
                        </div>
                    </div>
                    <p>Gracias por usar nuestro sistema de descarga de archivos, recuerde que el link estara disponible por un tiempo limitado</p>
                </div>
            </div>
            .
        </body>
        </html>';
        
        
        return $htmlContent;

    }

    function eliminar_acentos($cadena){
		
		//Reemplazamos la A y a
		$cadena = str_replace(
		array('Á', 'À', 'Â', 'Ä', 'á', 'à', 'ä', 'â', 'ª'),
		array('A', 'A', 'A', 'A', 'a', 'a', 'a', 'a', 'a'),
		$cadena
		);

		//Reemplazamos la E y e
		$cadena = str_replace(
		array('É', 'È', 'Ê', 'Ë', 'é', 'è', 'ë', 'ê'),
		array('E', 'E', 'E', 'E', 'e', 'e', 'e', 'e'),
		$cadena );

		//Reemplazamos la I y i
		$cadena = str_replace(
		array('Í', 'Ì', 'Ï', 'Î', 'í', 'ì', 'ï', 'î'),
		array('I', 'I', 'I', 'I', 'i', 'i', 'i', 'i'),
		$cadena );

		//Reemplazamos la O y o
		$cadena = str_replace(
		array('Ó', 'Ò', 'Ö', 'Ô', 'ó', 'ò', 'ö', 'ô'),
		array('O', 'O', 'O', 'O', 'o', 'o', 'o', 'o'),
		$cadena );

		//Reemplazamos la U y u
		$cadena = str_replace(
		array('Ú', 'Ù', 'Û', 'Ü', 'ú', 'ù', 'ü', 'û'),
		array('U', 'U', 'U', 'U', 'u', 'u', 'u', 'u'),
		$cadena );

		//Reemplazamos la N, n, C y c
		$cadena = str_replace(
		array('Ñ', 'ñ', 'Ç', 'ç'),
		array('N', 'n', 'C', 'c'),
		$cadena
		);
		
		return $cadena;
	}

    // public function toemail($estacion, $inicio, $fin, $email)
    // {
    //     // $metrica =  new Metrica();
    //     // $res = $metrica->obtenerInfoStationByDataToExcel($estacion, $inicio, $fin);
    //     // $table = "";
    //     // $table .= "<table>";
    //     // $table .= "<thead> <th>Fecha</th> <th>Altura [cm]</th><th>Caudal [L/s]</th></thead>";
    //     // $results = $res->fetchAll(PDO::FETCH_OBJ);
    //     // foreach ($results as $r) {
    //     //     $table .= "<tr><td>".$r->date."</td><td>".$r->altmm."</td><td>".$r->flow."</td></tr>";
    //     // }
    //     // $table .= "</table>";
    //     // header("Content-type: application/vnd.ms-excel");
    //     // //header("Content-Disposition: attachment; filename=registros_" . time() . ".xls");
    //     // header("Content-Disposition: attachment; filename=registros.xls");
    //     // header("Pragma: no-cache");
    //     // header("Expires: 0");
    //     // file_put_contents("/home/wwhidr/monitorehidrico.cl/Website/api/registros.xls",  $table);

    //     // $to = $email;
    //     // //sender
    //     // $from = 'info@monitoreohidrico.cl';
    //     // $fromName = 'monitoreo';
    //     // //email subject
    //     // $subject = 'PHP Email with Attachment';
    //     // //attachment file path
    //     // $file = 'Libro1.xls';
    //     // //email body content
    //     // $txtContent = 'PHP Email with Attachment
    //     // This email has sent from PHP script with attachment.';
    //     // //boundary
    //     // $mime_boundary = md5("monitoreo");
    //     // //headers for attachment
    //     // $headers = "MIME-Version: 1.0\r\n";
    //     // $headers .= "From:" .  $fromName . "\r\n";
    //     // $headers .= "Replay-To: " . $from . " 1.0" . "\r\n";
    //     // $headers .= "Content-Type: multipart/mixed; boundary = $mime_boundary\r\n\r\n";
    //     // //multipart boundary
    //     // $message = "--$mime_boundary\r\n";
    //     // $message .= "Content-Type: text/plain; charset=ISO-8859-1\r\n";
    //     // $message .= "Content-Transfer-Encoding: base64\r\n\r\n";
    //     // $message .= chunk_split(base64_encode($txtContent));
    //     // // Boundary
    //     // $filecreate = 'nofile';
    //     // //preparing attachment
    //     // if (!empty($file) > 0) {
    //     //     if (is_file($file)) {
    //     //         $filecreate = 'filecreate';
    //     //         $message .= "--$mime_boundary\r\n";
    //     //         $fp =    @fopen($file, "rb");
    //     //         $data =  @fread($fp, filesize($file));

    //     //         @fclose($fp);
    //     //         $data = chunk_split(base64_encode($data));
    //     //         $message .= "Content-Type: application/octet-stream; name=\"" . basename($file) . "\"\n" .
    //     //             "Content-Description: " . basename($file) . "\n" .
    //     //             "Content-Disposition: attachment;\n" . " filename=\"" . basename($file) . "\"; size=" . filesize($file) . ";\n" .
    //     //             "Content-Transfer-Encoding: base64\n\n" . $data . "\n\n";
    //     //     }
    //     // }
    //     // $message .= "--{$mime_boundary}--";
    //     // $returnpath = "-f" . $from;
    //     // //send email
    //     // $mail = @mail($to, $subject, $message, $headers, $returnpath);
    //     // // Email sending status
    //     // // $obj = new stdClass();
    //     // // $obj->archivo = $email;
    //     // //echo json_encode($mail ? "Email Sent Successfully! $filecreate" : "Email sending failed.");
    //     // echo json_encode($table);
    // }

    //  while ($filee = readdir($directory)) //obtenemos un archivo y luego otro sucesivamente
    //      {
    //       if (is_dir($filee))//verificamos si es o no un directorio
    //       {
    //         echo "[".$filee . "]<br />"; //de ser un directorio lo envolvemos entre corchetes
    //       }
    //       else
    //      {
    //        echo $filee . "<br />";
    //      }
    //      }
}
