<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
      <!-- magen-iot-admin CSS -->
  <link rel="stylesheet" href="../template/css/magen-iot-admin.css">
<style>


#sending{
  margin-top: 16px;
}
</style>
    <title>Document</title>
</head>
<body>

              <!-- PROGRESS BAR -->
              <!-- <div id="sending" class="col-lg-12" style="display:none;"> -->

         <div class="container mw-100 p-2">
          <div class="row p-2">
            <div class="col-12 justifify-content-center align-items-center shadow-sm p-3 mb-5 bg-white rounded">
            <label for="select_script_station">Estation</label>
              <select id="select_script_station" class="custom-select">
                <option value="todas" selected>Todas</option>
              </select>
              <label for="select_script_mode">Modo</label>
              <select id="select_script_mode" class="custom-select">
                <option value="day" selected>Acumulado Dia</option>
                <option value="week">Acumulado Semana</option>
                <option value="month">Acumulado Mes</option>
                <option value="year">Acumulado Año</option>
              </select>
              <button class="btn btn-primary cursor-pointer" onclick="init()">Solicitar actualizacion</button>
              <button class="btn btn-light cursor-pointer" onclick="cancel()">Cancelar</button>
            </div>

            <div id="sending" class="col-12 row">
            </div>
            
          </div>

         </div>
              <!-- END PROGRESS BAR -->
  <script src="../template/lib/jquery/jquery.js"></script>
  <script src="../template/lib/popper.js/popper.js"></script>
  <script src="../template/lib/bootstrap/bootstrap.js"></script>
  <script src="../template/lib/perfect-scrollbar/js/perfect-scrollbar.jquery.js"></script>
  <script src="../template/lib/moment/moment.js"></script>
  <!-- <script src="../template/lib/d3/d3.js"></script> -->
  <script src="../template/js/magen-iot-admin.js"></script>
  <!-- <script src="../template/js/ResizeSensor.js"></script> -->

  <script>

    let stations=[];
    let endProcess=false;

    function cancel(){
      endProcess=true;
    }
      
  async function loadStationSelect(){
    console.log('cargando estaciones en selects...');
    const stationSelect=document.getElementById("select_script_station")
    stations = await getAllStations() || [];
    
    if (!stations || stations.length<1) {
      return;
    }
      stations.forEach((station,index)=>{
        const option =document.createElement('option');
        option.value=station.idest;
        option.text=station.nombre;
        stationSelect.appendChild(option)
      });



    console.log('Finalizado selects estaciones');

  }


  async function init(){
    console.log('iniciando proceso de actualizacion...');
    const stationSelected=document.getElementById("select_script_station").value;
    const modo=document.getElementById("select_script_mode").value;
    endProcess=false;

    let stationsSelectedsValues;

    if (stationSelected=="todas") {
      stationsSelectedsValues=stations;
    } else {
      stationsSelectedsValues=stations.filter((station)=>{
        return (station.idest==stationSelected)
      });
    }
    
    if (!stationsSelectedsValues || stationsSelectedsValues.length<1) {
      return;
    }

    for (const station of stationsSelectedsValues) {
      if (endProcess===true) {
      return; 
     }

     await runScriptUpdateAc(station.idest,station.nombre,0,10000,station.tiempo,modo,null,null);
    }
    console.log('Finalizado el proceso de actualizacion');

  }

  async function getAllStations(){
    const response=await postData('updateAcRowsApi.php',{
     endpoint:'all-stations'
    })

    return response;
  }

  async function postData(url = '', data = {}) {

    let myHeaders = new Headers();
    myHeaders.append('Content-Type', 'application/json');
    const response =await fetch(url, {
      method: 'post', // *GET, POST, PUT, DELETE, etc.
      mode: 'cors', // no-cors, *cors, same-origin
      cache: 'no-cache', // *default, no-cache, reload, force-cache, only-if-cached
      credentials: 'same-origin', // include, *same-origin, omit
      headers: myHeaders,
      redirect: 'follow', // manual, *follow, error
      referrerPolicy: 'no-referrer', // no-referrer, *no-referrer-when-downgrade, origin, origin-when-cross-origin, same-origin, strict-origin, strict-origin-when-cross-origin, unsafe-url
      body: JSON.stringify(data) // body data type must match "Content-Type" header
    }).then(response => { return response.json(); });
    return response; // parses JSON response into native JavaScript objects
}

  async function runScriptUpdateAc(station,name,offset,limit,time,option,previousDate,previousValue){
    if (endProcess===true) {
      return false; 
     }


    const response=await postData('updateAcRowsApi.php',{
     endpoint:'calc_ac_generic_with_previous_data', station,offset,limit,time,name,option,previousDate,previousValue
    })

    if (offset<response.total) {
      setStationProgress(response);
      return await runScriptUpdateAc(station,name,(offset+limit),limit,time,option,response.previousDate,response.previousValue)
    } else {
      return false;
    }

    return response;
  }


  function setStationProgress(station){

    let stationDiv = document.getElementById(station.id);

    if (!stationDiv) {
      createNewBar(station);
      stationDiv = document.getElementById(station.id);
    }

      const percent=(station.done*100/station.total).toFixed(2);
      document.getElementById('bar_'+station.id).style='width:'+percent+'%';
      document.getElementById('bar_'+station.id).innerText=percent;
      document.getElementById('counter_'+station.id).innerText=station.done+"/"+station.total;

  }

  function createNewBar(station){

        const mainDiv= document.getElementById('sending');
        const containerSingleBarDiv= document.createElement('div');
        containerSingleBarDiv.className="col-12 col-md-6 col-lg-4 col-xl-3 col-xxl-2 p-2"
        const title= document.createElement('h6');
        const nameStation= document.createElement('span');
        nameStation.id=station.id;
        nameStation.innerText=station.name;

        title.appendChild(nameStation);
        containerSingleBarDiv.appendChild(title);

        const progressDiv= document.createElement('div');
        progressDiv.className="progress";

        const barDiv= document.createElement('div');
        barDiv.id="bar_"+station.id;
        barDiv.className="progress-bar progress-bar-success progress-bar-striped active";
        barDiv.setAttribute("role","progressbar");
        barDiv.setAttribute("aria-valuenow","40");
        barDiv.setAttribute("aria-valuemin","0");
        barDiv.setAttribute("aria-valuemax","100");
        barDiv.setAttribute("data-progress","0");
        barDiv.style="width: 0%;"
        barDiv.innerText="0%;"

        progressDiv.appendChild(barDiv);
        containerSingleBarDiv.appendChild(progressDiv);

        const counterDiv= document.createElement("div");
        counterDiv.id="counter_"+station.id;
        counterDiv.className="counter-sending";
        counterDiv.innerText=station.done+"/"+station.total;

        containerSingleBarDiv.appendChild(counterDiv);

        mainDiv.appendChild(containerSingleBarDiv);

  }

  loadStationSelect();

  </script>

</body>
</html>


