<?php
set_time_limit(0);
Header("Access-Control-Allow-Origin: *");
Header("Access-Control-Allow-Credentials: true");
Header("Access-Control-Allow-Methods: GET,HEAD,OPTIONS,POST,PUT");
Header("Access-Control-Allow-Headers: access-control-expose-headers, Origin,Accept, X-Requested-With, Content-Type, Access-Control-Request-Method, Access-Control-Request-Headers");

date_default_timezone_set('America/Santiago');

$contentType = isset($_SERVER["CONTENT_TYPE"]) ? trim($_SERVER["CONTENT_TYPE"]) : '';

if ($contentType === "application/json") {
    $content = trim(file_get_contents("php://input"));

    $decoded = json_decode($content, true);

    if (is_array($decoded)) {
        $endpoint = $decoded['endpoint'];
        include_once 'metrica.php';
        $obj=new Metrica();
        // include_once 'apimetricas.php';
        // $api = new Apimetricas();
        switch ($endpoint) {
          case 'all-stations':
            
            echo json_encode($obj->obtenerStations()->fetchAll());
            break;
          case 'get_ac': 
            $station= $decoded['station'];
            // $option= $decoded['option'];
            // $start= $decoded['start'];
            // $end= $decoded['end'];

            $acu=getAcumuladoToGraph($station);

             echo json_encode($acu);
            break;
          case 'get_ac_single': 
            $station= $decoded['station'];
            $option= $decoded['option'];
            $startDate= $decoded['startDate'];

            $acu=getAcumuladoToSingleGraph($station,$option,$startDate);

             echo json_encode($acu);
            break;
          case 'calc_ac_generic':


            $station= $decoded['station'];
            $name= $decoded['name'];
            $option= $decoded['option'];
            $time= $decoded['time'];
            $offset= $decoded['offset'];
            $limit= $decoded['limit'];
            

            $totalData=$obj->obtenerTotalRows($station)->fetchAll()[0]['total'];

            $res=$obj->obtenerColumnsStationOrdered($station, 'date', 'ASC', $offset,$limit);
            $totalToProcess=$res->rowCount();

            if ($totalToProcess) {
              while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                $end= $row['date'];
                $start=getStartDate($option,$end);

                if ($start!="-0001-11-30 00:00:00" && $end!="0000-00-00 00:00:00") {
                    $column=getColumnName($option);
                    $acu=getAcumulado($option,$station,$start,$end,$time);
                    $obj->updateSingleColumn($station,$end,$column,$acu);
                  }
                 
              }
            }


             echo json_encode(getFormatResponse($station,$name,$offset+$totalToProcess,$totalData));
            break;
          case 'calc_ac_generic_with_previous_data':

            $station= $decoded['station'];
            $name= $decoded['name'];
            $option= $decoded['option'];
            $time= $decoded['time'];
            $offset= $decoded['offset'];
            $limit= $decoded['limit'];
            $previousDate= $decoded['previousDate'];
            $previousValue= $decoded['previousValue'];
            

            $totalData=$obj->obtenerTotalRows($station)->fetchAll()[0]['total'];
            $column=getColumnName($option);
            $res=$obj->obtenerColumnsStationOrdered($station, 'date,flow', 'ASC', $offset,$limit);
            $totalToProcess=$res->rowCount();
            $newDate='';
            $acu='';
            $done=0;
            if ($totalToProcess) {
              while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                $done++;
                $newDate= $row['date'];
                $flow= $row['flow'];
                $start=getStartDate($option,$newDate);
                if ($start!="-0001-11-30 00:00:00" && $newDate!="0000-00-00 00:00:00") {
                    $acu=getAcumuladoWithPreviousData($option,$previousDate,$previousValue,$newDate,$flow,$time);

                    $datePrevious=getDateFromOption($option,$previousDate);
                    $dateCurrent=getDateFromOption($option,$newDate);

                    if ($datePrevious!==$dateCurrent) {
                      $obj->updateSingleColumn($station,$previousDate,$column,$previousValue);
                    }elseif ($done>=$totalToProcess) {
                      $obj->updateSingleColumn($station,$previousDate,$column,$previousValue);
                    }
                    
                    // $obj->updateSingleColumn($station,$newDate,$column,$acu);
                    $previousDate=$newDate;
                    $previousValue=$acu;
                  }
                 
              }
            }

             echo json_encode(getFormatResponseWithPreviousData($station,$name,$offset+$totalToProcess,$totalData,$newDate,$acu));
            break;
          default:
          echo json_encode($station.','.$offset.','.$limit);
            break;
        }

        
        
        

    } else {
        echo json_last_error();
    }
}

exit();
die();




function getFormatResponse($id,$name,$done,$total){
  if ($done>$total) {
    $done=$total;
  }
  return array(
    'name' => $name,
    'id' => $id,
    'done' => $done,
    'total' => $total,
  );
}
function getFormatResponseWithPreviousData($id,$name,$done,$total,$previousDate,$previousValue){
  if ($done>$total) {
    $done=$total;
  }
  return array(
    'name' => $name,
    'id' => $id,
    'done' => $done,
    'total' => $total,
    'previousDate' => $previousDate,
    'previousValue' => $previousValue,
  );
}

function getDateFromOption($option,$dateString){
  $date='';
  switch ($option) {
    case 'day':
      $date  =  date('Y-m-d', strtotime($dateString));
      break;
    case 'week':
      $date  =  date("Y-W", strtotime($dateString));
      break;
    case 'month':
      $date  =  date('Y-m', strtotime($dateString));
      break;
    case 'year':
      $date  =  date('Y', strtotime($dateString));
      break;
    default:
      $date  =  date('Y-m-d', strtotime($dateString));
      break;
  }

  return $date;
}
function getStartDate($option,$dateEnd){
  $date='';
  switch ($option) {
    case 'day':
      $date  =  date('Y-m-d', strtotime($dateEnd))." 00:00:00";
      break;
    case 'week':
      $year  =  date('Y', strtotime($dateEnd));
      $semana  =  date('W', strtotime($dateEnd));
      $date  =  (new DateTime())->setISODate($year, $semana)->format('Y-m-d')." 00:00:00";
      break;
    case 'month':
      $date  =  date('Y-m', strtotime($dateEnd))."-01 00:00:00";
      break;
    case 'year':
      $date  =  date('Y', strtotime($dateEnd))."-01-01 00:00:00";
      break;
    
    default:
      $date=$dateEnd;
      break;
  }

  return $date;
}
function getEndDateToGrap($option,$dateCurrent){
  $date='';
  switch ($option) {
    case 'month':
      $year  =  date('Y', strtotime($dateCurrent));
      $month  =  date('m', strtotime($dateCurrent));
      $days = cal_days_in_month(CAL_GREGORIAN, $month, $year);
      $date  =  date('Y-m', strtotime($dateCurrent))."-{$days} 23:59:59";
      break;
    case 'year':
      $date  =  date('Y', strtotime($dateCurrent))."-12-31 23:59:59";
      break;
    
    default:
      $year  =  date('Y', strtotime($dateCurrent));
      $month  =  date('m', strtotime($dateCurrent));
      $days = cal_days_in_month(CAL_GREGORIAN, $month, $year);
      $date  =  date('Y-m', strtotime($dateCurrent))."-{$days} 23:59:59";
      break;
  }

  

    // $date = new DateTime('now');
    // $date->modify('last day of this month');
    // echo $date->format('Y-m-d');

    //   $month = date('m');
    //   $year = date('Y');
    //   $day = date("d", mktime(0,0,0, $month+1, 0, $year));

      // return date('Y-m-d', mktime(0,0,0, $month, $day, $year));


  return $date;
}
function getColumnName($option){
  $name='';
  switch ($option) {
    case 'day':
      $name= 'ac_day';
      break;
    case 'week':
      $name= 'ac_week';
      break;
    case 'month':
      $name= 'ac_month';
      break;
    case 'year':
      $name= 'ac_year';
      break;
    
    default:
      $name= 'ac_day';
      break;
  }

  return $name;
}

function getAcumuladoWithPreviousData($option,$previousDate,$previousValue,$newDate,$flow,$time){
  

      $newValue=($flow*$time)/1000;

      if ($previousDate==null || $previousValue == null ) {
        return $newValue;
      }

      $datePrevious=getDateFromOption($option,$previousDate);
      $dateCurrent=getDateFromOption($option,$newDate);

      if ($datePrevious==$dateCurrent) {
        return ($previousValue+$newValue);
      }else {
       return $newValue;
      }

}
function getAcumulado($option,$station,$start,$end,$time){
      include_once 'metrica.php';
      $obj=new Metrica();     
    switch ($option) {
      case 'day':
        $acu=$obj->obtenerAcDiaDato($station, $start, $end, $time)->fetchAll();
        break;
      case 'week':
        $acu=$obj->obtenerAcMonthorWeek($station, $start, $end)->fetchAll();
        break;
      case 'month':
        $acu=$obj->obtenerAcMonthorWeek($station, $start, $end)->fetchAll();
        break;
      case 'year':
        $acu=$obj->obtenerAcYear($station, $start, $end)->fetchAll();
        break;
      
      default:
      $acu=$obj->obtenerAcDiaDato($station, $start, $end, $time)->fetchAll();
        break;
    }

    return $acu[0]['acu'];

}
function getAcumuladoToGraph($station){
      include_once 'metrica.php';
      $obj=new Metrica(); 
      
      $currentDate = date('Y-m-d G:i:s');

      $startMonth=getStartDate('month',$currentDate);
      $startYear=getStartDate('year',$currentDate);

      $endMonth =getEndDateToGrap('month',$currentDate);
      $endYear =getEndDateToGrap('year',$currentDate);

      $daily=$obj->obtenerAcDaily($station, $startMonth, $endMonth)->fetchAll();
      $monthly=$obj->obtenerAcMonthly($station, $startYear, $endYear)->fetchAll();
      $annual=$obj->obtenerAcAnnual($station)->fetchAll();

      return array(
        'id' => $station,
        'daily' => $daily,
        'monthly' => $monthly,
        'annual' => $annual,
      );
    // switch ($option) {
    //   case 'daily':
    //     $acu=$obj->obtenerAcDaily($station, $start, $end)->fetchAll();
    //     break;
    //   case 'monthly':
    //     $acu=$obj->obtenerAcMonthly($station, $start, $end)->fetchAll();
    //     break;
    //   case 'annual':
    //     $acu=$obj->obtenerAcAnnual($station, $start, $end)->fetchAll();
    //     break;
      
    //   default:
    //     $acu=$obj->obtenerAcDaily($station, $start, $end)->fetchAll();
    //     break;
    // }

    return $acu[0]['acu'];

}
function getAcumuladoToSingleGraph($station,$option,$startDate){
      include_once 'metrica.php';
      $obj=new Metrica(); 
      
      $acu;

      $startMonth=getStartDate('month',$startDate);
      $startYear=getStartDate('year',$startDate);

      $endMonth =getEndDateToGrap('month',$startDate);
      $endYear =getEndDateToGrap('year',$startDate);

      switch ($option) {
        case 'month':
          $acu=$obj->obtenerAcDaily($station, $startMonth, $endMonth)->fetchAll();
          break;
        case 'annual':
          $acu=$obj->obtenerAcMonthly($station, $startYear, $endYear)->fetchAll();
          break;
        
        default:
          $acu=$obj->obtenerAcDaily($station, $startMonth, $endMonth)->fetchAll();
          break;
      }

      return $acu;


}


?>
