function iniMapLeaflet(idMap,centro,zoom,Textmarker){
    var mymap = L.map(idMap, {
        closePopupOnClick: false
    }).setView(centro, zoom);
    L.tileLayer('https://api.mapbox.com/styles/v1/{id}/tiles/{z}/{x}/{y}?access_token=pk.eyJ1IjoiYXlvbmdwIiwiYSI6ImNsZzJ6bWZyeTAyc3gzZ3Izc3ViZHc4eXQifQ.bZ8rD1sKONNzFxFeZMMSFA', {
        attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors, Imagery © <a href="https://www.mapbox.com/">Mapbox</a>',
        maxZoom: 18,
        id: 'mapbox/satellite-v9',
        tileSize: 512,
        zoomOffset: -1,
        accessToken: 'your.mapbox.access.token'
    }).addTo(mymap);

    if(Textmarker!=null){
        var marker = L.marker(centro).addTo(mymap);
        marker.bindPopup(Textmarker).openPopup();
    }


return mymap;
}

function iniMapLeaflet2(map){
    L.tileLayer('https://api.mapbox.com/styles/v1/{id}/tiles/{z}/{x}/{y}?access_token=pk.eyJ1IjoiYXlvbmdwIiwiYSI6ImNsZzJ6bWZyeTAyc3gzZ3Izc3ViZHc4eXQifQ.bZ8rD1sKONNzFxFeZMMSFA', {
        attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors, Imagery © <a href="https://www.mapbox.com/">Mapbox</a>',
        maxZoom: 18,
        id: 'mapbox/satellite-v9',
        tileSize: 512,
        zoomOffset: -1,
        accessToken: 'your.mapbox.access.token'
    }).addTo(map);

    return mymap;
}

function setCircleLeaflet(map,centro,radius,Textmarker){
    var circle = L.circle(centro, {
        color: 'red',
        fillColor: '#f03',
        fillOpacity: 0.5,
        radius: radius
    }).addTo(map);
    circle.bindPopup(Textmarker);
}
        
async function setPolygonLeaflet(map,coord,centro,zoom,Textmarker,opciones){
    var idMap=map._container.id;
    var centro1=map.getCenter();
    var zoom1=map.getZoom();
    console.log(idMap);

    map.remove();

    map= iniMapLeaflet(idMap,centro1,zoom1);
    
    var polygon = L.polygon(coord, opciones).addTo(map);
    map.setView(centro);
    map.setZoom(zoom);
    polygon.bindPopup(Textmarker).openPopup();

    return map;
}
       
function setMarkersLeaflet(map, marcadores) {
   
    let coord=Array();
    for (var i = 0; i < marcadores.length; i++) {
        let lat = marcadores[i][1];
        let lon = marcadores[i][2];
        marker = L.marker([lat, lon]).addTo(map);
        coord[i] = [lat, lon];
        marker.bindPopup(marcadores[i][6], {
                autoClose: true,
                autoPan: false,
                className: 'marker'
            })
        .openPopup()


    }

  map.fitBounds([coord]);
}

function setMarkersLeaflet2(map, marcadores) {
            // Definir los iconos y colores de los marcadores según el tipo de punto
        var iconos = {
            '1': L.icon({ iconUrl: 'https://cdn.rawgit.com/pointhi/leaflet-color-markers/master/img/marker-icon-green.png', iconSize: [25, 41], iconAnchor: [12, 41], popupAnchor: [1, -34], shadowSize: [41, 41]}),
            '2': L.icon({ iconUrl: 'https://cdn.rawgit.com/pointhi/leaflet-color-markers/master/img/marker-icon-blue.png', iconSize: [25, 41], iconAnchor: [12, 41], popupAnchor: [1, -34], shadowSize: [41, 41] }),
            '3': L.icon({ iconUrl: 'https://cdn.rawgit.com/pointhi/leaflet-color-markers/master/img/marker-icon-violet.png', iconSize: [25, 41], iconAnchor: [12, 41], popupAnchor: [1, -34], shadowSize: [41, 41] }),
            '4': L.icon({ iconUrl: 'https://cdn.rawgit.com/pointhi/leaflet-color-markers/master/img/marker-icon-gold.png', iconSize: [25, 41], iconAnchor: [12, 41], popupAnchor: [1, -34], shadowSize: [41, 41] }),
            '5': L.icon({ iconUrl: 'https://cdn.rawgit.com/pointhi/leaflet-color-markers/master/img/marker-icon-orange.png', iconSize: [25, 41], iconAnchor: [12, 41], popupAnchor: [1, -34], shadowSize: [41, 41] }),
            '6': L.icon({ iconUrl: 'https://cdn.rawgit.com/pointhi/leaflet-color-markers/master/img/marker-icon-red.png', iconSize: [25, 41], iconAnchor: [12, 41], popupAnchor: [1, -34], shadowSize: [41, 41] })
        };
    let coord=Array();
    for (var i = 0; i < marcadores.length; i++) {
        let lat = marcadores[i][1];
        let lon = marcadores[i][2];
        marker = L.marker([lat, lon], { icon: iconos[marcadores[i][7]]},{
          title: marcadores[i][6]
        }).addTo(map);
        coord[i] = [lat, lon];
      marker.bindPopup(marcadores[i][0], {
                  autoClose: false,
                  autoPan: false,
                  className: 'marker'
              })
    }

  map.fitBounds([coord]);
  



        // Agregar leyenda
        var leyenda = L.control({ position: 'topleft' });

        leyenda.onAdd = function (map) {
            var div = L.DomUtil.create('div', 'info legend');
            div.innerHTML += '<h4>Tipos</h4>';
            div.innerHTML += '<div><img src="https://cdn.rawgit.com/pointhi/leaflet-color-markers/master/img/marker-icon-green.png"> Canales</div>';
            div.innerHTML += '<div><img src="https://cdn.rawgit.com/pointhi/leaflet-color-markers/master/img/marker-icon-red.png"> Ríos</div>';
            div.innerHTML += '<div><img src="https://cdn.rawgit.com/pointhi/leaflet-color-markers/master/img/marker-icon-blue.png"> Subterráneas</div>';
            div.innerHTML += '<div><img src="https://cdn.rawgit.com/pointhi/leaflet-color-markers/master/img/marker-icon-violet.png"> Compuertas</div>';
            div.innerHTML += '<div><img src="https://cdn.rawgit.com/pointhi/leaflet-color-markers/master/img/marker-icon-gold.png"> Embalses</div>';
            div.innerHTML += '<div><img src="https://cdn.rawgit.com/pointhi/leaflet-color-markers/master/img/marker-icon-orange.png"> Calidad</div>';
            return div;
        };

        leyenda.addTo(map);
}

function setMarkersLeafletCluster(map, marcadores) {
    console.log(marcadores);
    let zoom_ini = map.getZoom()

    var markers = new L.markerClusterGroup({
        showCoverageOnHover: false,      
    });
    for (var i = 0; i < marcadores.length; i++) {
        let lat = marcadores[i][1];
        let lon = marcadores[i][2];
        marker = L.marker([lat, lon]);

        marker.bindPopup(marcadores[i][6], {
                autoClose: false,
                autoPan: false,
                className:'marker'
            })
        .openPopup()

        markers.addLayer(marker);

    }

   
    map.addLayer(markers);

    
    var bounds;
    var markersDisplayed = false;
    bounds = map.getBounds();
    markers.eachLayer(function (layer) {
        if (bounds.contains(layer.getLatLng())) {
            layer.openPopup();
        }
    });
    


    map.on('moveend zoomend', function(e) {
      bounds = map.getBounds();
      var zoom = map.getZoom();
        if (zoom > zoom_ini) {
        markers.eachLayer(function (layer) {
          if (bounds.contains(layer.getLatLng())) {
            markersDisplayed = true;
            layer.openPopup();
          }
        });
        }
      else if (markersDisplayed) {
        markersDisplayed = false;
        markers.eachLayer(function (layer) {
          if (bounds.contains(layer.getLatLng())) {
            layer.closePopup();
          }
        });
      }
    });

    markers.on('clusterclick', function (e) {
      bounds = map.getBounds();
      var zoom = map.getZoom();
      var childMarkers = e.layer.getAllChildMarkers();
        if (zoom > zoom_ini) {
        childMarkers.eachLayer(function (layer) {
          if (bounds.contains(layer.getLatLng())) {
            markersDisplayed = true;
            layer.openPopup();
          }
        });
      }
    });




}
