/* globals Chart:false, feather:false */

const URLall = 'api/all.php'

var CurrentStation;
var DatosEstacion;
var DatosFecha = new Array();
var tablaToShow = new Array();
var usuario = new Array();
let organizacion;

let columnasFile = [];
let fileInput = document.getElementById("csvFile");
let checkbox = document.getElementById('primera_fila');

let fielsdBDMySql = ["date", "distmm", "timex2S", "tempC", "altmm", "station", "flow", "volume", "accumulated", "ac_day", "ac_week", "ac_month", "ac_year", "state", "create_date_time", "update_date_time"];
let fieldsCsvFile=[];

let estacionesList;
let offsetGlobal=0;
let pilaGlobal=0;
let cancel=false;

function agregarLinkestaciones(arrayfile, idContainer) {
    // *********************


    Ncolumna = arrayfile[0].length;  // cuenta los elementos del headers
    Nfila = arrayfile.length;      // cuenta la cantidad de registro


    // Obtener la referencia del elemento contenedor
    var body = document.getElementById(idContainer);


    var ul = document.createElement("ul");
    ul.id = "ulEstaciones";
    ul.style = "left: -25px; position: relative;"



    for (var i = 1; i < Nfila; i++) {

        var li = document.createElement("li");
        li.className = "nav-item";
        li.style = "height: fit-content; padding-top: 5px; padding-bottom: 5px; color:white;"
        var a = document.createElement("a");
        a.className = "nav-link";
        a.href = "#";
        a.textContent = arrayfile[i][1];
        li.appendChild(a);
        li.setAttribute("onclick", "verEstacion('" + arrayfile[i][0] + "')");
        ul.appendChild(li);

    }


    body.appendChild(ul);

    // *********************
}

function agregarLinkestacionesParam(arrayfile, idContainer) {
    // *********************


    Ncolumna = arrayfile[0].length;  // cuenta los elementos del headers
    Nfila = arrayfile.length;      // cuenta la cantidad de registro


    // Obtener la referencia del elemento contenedor
    var body = document.getElementById(idContainer);


    var ul = document.createElement("ul");
    ul.id = "ulEstaciones";
    ul.style = "left: -25px; position: relative;"



    for (var i = 1; i < Nfila; i++) {

        var li = document.createElement("li");
        li.className = "nav-item";
        li.style = "height: fit-content; padding-top: 5px; padding-bottom: 5px; color:white;"
        var a = document.createElement("a");
        a.className = "nav-link";
        a.href = "#";
        a.textContent = arrayfile[i][1];
        li.appendChild(a);
        li.setAttribute("onclick", "irEstacionParam('" + arrayfile[i][0] + "')");
        ul.appendChild(li);

    }


    body.appendChild(ul);

    // *********************
}

async function jsonToArray(jsonFile) {
    items = jsonFile;
    var i = 0, result = [];

    while (i < items.length) {
        result.push([]);
        for (var key in items[i]) {
            result[result.length - 1].push(items[i][key]);
        }
        i++;
    }

    /*  console.log(result);
        console.log(result[0][4].city);
        console.log(data[0].address.city); */
    //  document.write(JSON.stringify(result, null, 4));

    return result;

}

async function obtenerJson(url, parametros) {
    return fetch(url, parametros)
        .then(response => { return response.json(); })
}

function addZero(i) {
    if (i < 10) {
        i = "0" + i;
    }
    return i;
}

async function showOrgStations(Org) {


    let file = new Array();



    let myHeaders = new Headers();
    myHeaders.append('Content-Type', 'application/json');
    const parametros = {
        method: 'post',
        headers: myHeaders,
        body: JSON.stringify({ "endpoint": 5, "organizacion": Org }),
        // body: JSON.stringify({"endpoint": 3 ,"estacion": estacion, "columnas":['station','altmm','date']}),
        cache: 'no-cache',
        mode: 'cors',
        cache: 'default'
    };

    tablaToShow.splice(0);

    file = await obtenerJson(URLall, parametros);
    estacionesList=file;
    
    tablaToShow = await jsonToArray(file.items);

    var claves = [];
    //con Object.keys(array) obtenemos las claves del objeto
    claves = Object.keys(file.items[0]);
    tablaToShow.unshift(claves);

   // Array2D_to_tablaHTML(tablaToShow, null, 'containertable');
    agregarLinkestaciones(tablaToShow, 'ListaEstaciones');
    agregarLinkestacionesParam(tablaToShow, 'ListaEstacionesParam');
    agregarEstacionToSelect();
}

async function irEstacionParam(idStation) {
    await SetGlobals({ 'view': 'views/paramStation.php', 'estacion': idStation });
    location.reload();
}

async function ver(idStation) {

    verEstacion(idStation);

}

async function modificar(NombreStation) {

    alert("modificar " + NombreStation);

}

async function eliminar(NombreStation) {

    alert("eliminar " + NombreStation);

}


async function infoUsers(user) {

    let myHeaders = new Headers();
    myHeaders.append('Content-Type', 'application/json');
    const parametros = {
        method: 'post',
        headers: myHeaders,
        body: JSON.stringify({ "endpoint": 7, "usuario": user }),
        cache: 'no-cache',
        mode: 'cors',
        cache: 'default'
    };


    usuario.splice(0);
    usuario = await obtenerJson(URLall, parametros);
    document.getElementById("userName").innerHTML = usuario.items[0].Nombre;
    organizacion = usuario.items[0].organizacion;
}


async function iniciar() {
    await infoUsers(usuarioActual);
    await showOrgStations(organizacion);
}

async function verEstacion(estacion) {

    await SetGlobals({ 'view': 'views/detailStation.php', 'estacion': estacion });
    location.reload();

}

async function SetNewView(view) {
    let myHeaders = new Headers();
    myHeaders.append('Content-Type', 'application/json');
    const parametros = {
        method: 'post',
        headers: myHeaders,
        body: JSON.stringify({ "endpoint": 13, "view": view }),
        cache: 'no-cache',
        mode: 'cors',
        cache: 'default'
    };

    var respuesta = await obtenerJson(URLall, parametros);
}

async function SetGlobals(variables) {

    let myHeaders = new Headers();
    myHeaders.append('Content-Type', 'application/json');
    const parametros = {
        method: 'post',
        headers: myHeaders,
        body: JSON.stringify({ "endpoint": 14, "variables": variables }),
        cache: 'no-cache',
        mode: 'cors',
        cache: 'default'
    };

    var respuesta = await obtenerJson(URLall, parametros);
}

async function GetGlobals(variable) {

    let myHeaders = new Headers();
    myHeaders.append('Content-Type', 'application/json');
    const parametros = {
        method: 'post',
        headers: myHeaders,
        body: JSON.stringify({ "endpoint": 15, "variable": variable }),
        cache: 'no-cache',
        mode: 'cors',
        cache: 'default'
    };

    var respuesta = await obtenerJson(URLall, parametros);
    console.log(respuesta);
    return respuesta.value;
}

async function showConfigView(){

}

async function message(state, msg='') {
    
    let messageBox = document.getElementById('outMessage');
    
    if (state == 'off') {
        messageBox.classList.add('d-none');       
        return;
    }

    messageBox.classList.remove('d-none');
    messageBox.classList.remove('bg-primary');
    messageBox.classList.remove('bg-success');
    messageBox.classList.remove('bg-danger');           
    
    if (state=='success'){
        messageBox.classList.add('bg-success');       
    } else if (state == 'error') {
        messageBox.classList.add('bg-danger');        
    }else{
        messageBox.classList.add('bg-primary');         
    }
    messageBox.innerText=msg;       

    
}

async function showElement(id,show) {
    
    let element = document.getElementById(id);
    
    if (show == false) {
        element.classList.add('d-none');       
    }else{
        element.classList.remove('d-none');
    }

        

    
}

function agregarEstacionToSelect(){

    let select = document.getElementById('selectStation');
    for (const estacion of estacionesList.items) {
        let option = document.createElement('option');
        option.value = estacion.Id;      
        option.innerText = estacion.Nombre;      
        select.appendChild(option);
    }
}

function getSelectBD() {
    let select = document.createElement('select');
    select.className ="form-control text-center"

    fielsdBDMySql.forEach(element => {
        let option = document.createElement('option');
        option.value = element;
        option.innerText = element;
        select.appendChild(option);
    });

    return select;

}

function getInputCSV() {
    let input = document.createElement('input');
    input.type="text"
    input.className ="form-control text-center"
    input.disabled="true";
    return input;

}

function getContainerSelect() {

    let container = document.createElement('div');
    container.className="col-6"
    
    return container;
}

function getRowContainerSelects() {

    let container = document.createElement('div');
    container.className = "col-12 my-2 row"
    
    return container;
}

function validaCheckbox() {
    buildFieldsFile();
    buildFieldsRow();
}

function buildFieldsFile() {

    if (checkbox.checked){   

        fieldsCsvFile = [...columnasFile];
    }else{
        cont=0;
        columnasFile.forEach(field => {
            cont++;
            fieldsCsvFile[cont-1] = 'V' + cont;
        });
    }
    
}

function buildFieldsRow() {

    let containerRowsFields = document.getElementById('container_fields');

    containerRowsFields.innerHTML="";
    let cont=0;
    fieldsCsvFile.forEach(element => {
        cont++;
        let RowContainerSelects = getRowContainerSelects();

        let containerSelect1 = getContainerSelect();
        let containerSelect2 = getContainerSelect();

        let InputCSV=getInputCSV();
        InputCSV.name="CSV" + cont;
        InputCSV.value = InputCSV.innerText = element;
        let selectBD=getSelectBD();
        selectBD.options[cont-1].selected="true";
        selectBD.name = "BD[]";

        containerSelect1.appendChild(InputCSV);
        containerSelect2.appendChild(selectBD);

        RowContainerSelects.appendChild(containerSelect1);
        RowContainerSelects.appendChild(containerSelect2);

        containerRowsFields.appendChild(RowContainerSelects);

        
    });


    
}

function getCodeProcess() {

    var hoy = new Date();
    var fecha = hoy.getFullYear() + (hoy.getMonth() + 1) + hoy.getDate();
    var hora = hoy.getHours() + hoy.getMinutes() + hoy.getSeconds();

    return fecha+hora;
}

async function view(view) {

    await SetGlobals({ 'view': 'views/'+view});
    location.reload();

}

async function checkProcess(codigo) {


    proceso=GetGlobals(codigo);
    console.log(proceso);
    // message('info', "Procesando:\n" + data.responseText);
    
}

readFile = function () {
    console.log(fileInput.files[0].type)
    if (!(fileInput.files[0].type!="application/vnd.ms-excel" || fileInput.files[0].type!="text/csv")) {
        
        message('error', 'Tipo de archivo incorrecto,  tipos permitidos: .csv ');
        return;
        
    }
        var reader = new FileReader();
        reader.onload = function () {
            // document.getElementById('out').innerHTML = reader.result;
           let columnasString =reader.result.substring(0, reader.result.indexOf("\r\n"));
           columnasFile=columnasString.split(',');
           
           validaCheckbox();
           message('success', 'Se ha cargado correctamente el archivo: ' + fileInput.files[0].name)
           showElement('ConfigView', true);      
           
        };
        // start reading the file. When it is done, calls the onload event defined above.
        if (!fileInput.files[0]) {
            message('error', 'Ha ocurrido un error cargando archivo')
            showElement('ConfigView', false);
        } else {                        
            reader.readAsText(fileInput.files[0]);
        }
        // reader.readAsBinaryString(fileInput.files[0]);
    };

$(document).ready(function () {

    $("#formulario").bind("submit", function () {

        


        if (offsetGlobal == 0) {
            $('#start_form').hide();
            $('#sending').show();
            $('#sended').text(0);
           
            //reset progress bar
            $('.progress-bar').css('width', '0%');
            $('.progress-bar').text('0%');
            $('.progress-bar').attr('data-progress', '0');
        }
        
        // Capturamnos el boton de envío
        var btnEnviar = $("#btnEnviar");
        var btnCancel = $("#btnCancel");
        data_=new FormData(this);
        data_.append('offset', offsetGlobal);
        $.ajax({
            type: $(this).attr("method"),
            url: $(this).attr("action"),
            data: data_,
            contentType: false,
            cache: false,
            processData: false,
            async: true, 
            // xhr: function () {
            //     var xhr = $.ajaxSettings.xhr();
            //     xhr.upload.onprogress = function (e) {
            //         console.log(Math.floor(e.loaded / e.total * 100) + '%');
            //     };
            //     return xhr;
            // },
            // data: $(this).serialize(),
            // data: data,
            beforeSend: function () {
                /*
                * Esta función se ejecuta durante el envió de la petición al
                * servidor.
                * */
                // btnEnviar.text("Enviando"); Para button 

                btnEnviar.val("Enviando"); // Para input de tipo button
                btnEnviar.attr("disabled", "disabled");
                btnCancel.removeAttr("disabled");
            },
            complete: function (data) {
                /*
                * Se ejecuta al termino de la petición
                * */

                // btnEnviar.val("Enviar formulario");
                // btnEnviar.removeAttr("disabled");
               
            },
            success: function (data) {
                /*
                * Se ejecuta cuando termina la petición y esta ha sido
                * correcta
                * */
               
                //  message('info', "Procesando:\n"+data);
                console.log(data)
                result=JSON.parse(data);

                $('#total').text(result.totalfilas);
                $('.progress-bar').css('width', result.porcentaje + '%');
                $('.progress-bar').text(result.porcentaje + '%');
                $('.progress-bar').attr('data-progress', result.porcentaje);
                $('#done').text(result.offset);

                if (result.complete) {
                    message('success', "¡Carga Terminada!\n\n" + result.informe);
                    btnEnviar.removeAttr("disabled"); 
                    $('.end-process').show();     
                } else {
                    pilaGlobal++;
                    offsetGlobal = result.offset;
                    if (!cancel) {
                        $("#formulario").submit();                        
                    }else{
                        btnEnviar.removeAttr("disabled");
                        btnCancel.attr("disabled", "disabled");
                        offsetGlobal = 0;                        
                        message('info', "¡Carga Cancelada!\n\n" + result.informe);
                        if (pilaGlobal==0) {
                            cancel = false;
                        }
                    }
                }

                // $("#informe").html(data);
            },
            error: function (data) {
                /*
                * Se ejecuta si la peticón ha sido erronea
                * */
                alert("Problemas al tratar de enviar el formulario");
                message('error', data.statusText);
            }
        });
        // Nos permite cancelar el envio del formulario
        pilaGlobal--;
        return false;
    });
});

fileInput.addEventListener('change', readFile);
checkbox.addEventListener("change", validaCheckbox, false);

iniciar();



