/* globals Chart:false, feather:false */


const URLall = 'api/all.php'
const URLacu = 'api/updateAcRowsApi.php'
const URLstatistics = 'api/statisticsApi.php'
// const URLbase = 'http://localhost:8000/Monitoreo%20hidrico/Website/api/index.php'

var CurrentStation;
var DatosEstacion;
//VARIABLES DE LA GRAFICA
var DatosAltura = new Array();
var DatosCaudal = new Array();
var DatosFecha = new Array();
var DatosGra = new Array();
var DatosGraAltura = new Array();
var DatosGraCaudal = new Array();
var DatosGraAltura2 = new Array();
var DatosGraCaudal2 = new Array();

var tablaToShow = new Array();
var tablaToShow2 = new Array();
var tituloAltura
var tituloCaudal
var UnidadAltura
var UnidadCaudal
var invertirEje
var organizacion
var usuario = new Array();
let graphData;


async function jsonToArray(jsonFile) {
  items = jsonFile;
  var i = 0, result = [];

  //console.log(items)

  while (i < items.length) {
    result.push([]);
    for (var key in items[i]) {
      result[result.length - 1].push(items[i][key]);
    }
    i++;
  }

  //console.log(result);
  //console.log(result[0][4].city);
  //console.log(data[0].address.city); */
  //document.write(JSON.stringify(result, null, 4));

  return result;

}

async function obtenerJson(url, parametros) {
  return fetch(url, parametros)
    .then(response => { return response.json(); })
}

async function obtenerStationName(estacion) {

  let file = new Array();
  let file2 = new Array();


  let myHeaders = new Headers();
  myHeaders.append('Content-Type', 'application/json');
  const parametros = {
    method: 'post',
    headers: myHeaders,
    body: JSON.stringify({ "estacion": estacion, "endpoint": 4 }),
    cache: 'no-cache',
    mode: 'cors',
    cache: 'default'
  };

  file = await obtenerJson(URLall, parametros);
  var nombreestacion = document.getElementById('stationname');
  DatosFecha.splice(0);
  DatosEstacion = file.items[0];
  nombreestacion.innerHTML = DatosEstacion.Nombre;

  // nombreestacion.innerHTML=file.items[0].Nombre;
}

async function obtenerStation(estacion) {

  let file = new Array();
  let file2 = new Array();


  let myHeaders = new Headers();
  myHeaders.append('Content-Type', 'application/json');
  const parametros = {
    method: 'post',
    headers: myHeaders,
    body: JSON.stringify({ "estacion": estacion, "endpoint": 4 }),
    cache: 'no-cache',
    mode: 'cors',
    cache: 'default'
  };

  file = await obtenerJson(URLall, parametros);
  // var nombreestacion =document.getElementById('stationname');
  DatosEstacion = file.items[0];
}

async function getAcuToGraph(estacion) {
  CurrentStation = estacion;
  //console.log(CurrentStation)
  // await obtenerStation(estacion);
  let file = new Array();

  let myHeaders = new Headers();
  myHeaders.append('Content-Type', 'application/json');
  const parametros = {
    method: 'post',
    headers: myHeaders,
    body: JSON.stringify({ "endpoint": 'get_ac', "station": estacion }),
    cache: 'no-cache',
    mode: 'cors',
    cache: 'default'
  };

  file = await obtenerJson(URLacu, parametros);
  console.log(file)
  DataGraphDaily = [];
  DataGraphMonthly = [];
  DataGraphAnnual = [];
  const months = ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'];
  const categoriesMonth = file.monthly.map((month) => { return months[Number(month.date) - 1] });
  const categoriesDay = file.daily.map((day) => { return day.date })
  const categoriesYear = file.annual.map((year) => { return year.date })

  file.daily.forEach((data, index) => {
    if (file.daily.length == (index + 1) && data.acu == 0) {
      DataGraphDaily.push({
        name: 'Dia ' + data.date,
        y: parseFloat(Number(file.daily[index - 1]?.acu || 0).toFixed(2)),
        color: '#2196F3',
      });

    } else {
      DataGraphDaily.push({
        name: 'Dia ' + data.date,
        y: parseFloat(Number(data.acu).toFixed(2)),
        color: '#2196F3',
      });
    }

  })

  file.monthly.forEach((data, index) => {
    if (file.monthly.length == (index + 1) && data.acu == 0) {
      DataGraphMonthly.push({
        name: categoriesMonth[Number(data.date) - 1],
        y: parseFloat(Number(file.monthly[index - 1]?.acu || 0).toFixed(2)),
        color: '#3F51B5',
      });
    } else {
      DataGraphMonthly.push({
        name: categoriesMonth[Number(data.date) - 1],
        y: parseFloat(Number(data.acu).toFixed(2)),
        color: '#3F51B5',
      });
    }

  })

  file.annual.forEach((data, index) => {
    if (file.annual.length == (index + 1) && data.acu == 0) {
      DataGraphAnnual.push({
        name: data.date,
        y: parseFloat(Number(file.annual[index - 1]?.acu || 0).toFixed(2)),
        color: '#673AB7',
      });
    } else {
      DataGraphAnnual.push({
        name: data.date,
        y: parseFloat(Number(data.acu).toFixed(2)),
        color: '#673AB7',
      });
    }

  })

  buildGraph(DataGraphDaily, 'daily', categoriesDay, 'Volumen diario');
  buildGraph(DataGraphMonthly, 'monthly', categoriesMonth, 'Volumen mensual');
  buildGraph(DataGraphAnnual, 'annual', categoriesYear, 'Volumen anual');
}

async function buildGraph(DataGraph, id, categories) {

  Highcharts.setOptions({
    global: { useUTC: false },
    lang: {
      months: [
        'Enero', 'Febrero', 'Marzo', 'Abril',
        'Mayo', 'Junio', 'Julio', 'Agosto',
        'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'
      ],
      weekdays: [
        'Domingo', 'Lunes', 'Martes', 'Miercoles',
        'Jueves', 'Viernes', 'Sabado'
      ],
      decimalPoint: ',',
      thousandsSep: '.'
    },

  });


  return await Highcharts.chart(id, {
    chart: {
      type: 'column'
    },

    xAxis: {
      categories: categories,
    },

    title: {
      text: ''
    },

    yAxis: [
      {
        title: {
          text: 'Volumen',
        },
        labels: {
          formatter: function () {
            return Highcharts.numberFormat(this.value, 0, ",", ".");
          },
          format: '{value} m3'
        }
      }
    ],

    series: [{
      name: 'Volumen',
      data: DataGraph
    }],
    tooltip: {
      shared: true,
      crosshairs: true
    },
    legend: {
      enabled: false
    }
  });


  // return await Highcharts.chart(id, {
  //   chart: {
  //     zoomType: 'x',
  //     height: (9 / 16 * 70) + '%',
  //     type:'column'
  //   },

  //   title: {
  //     text: ''
  //   },

  //   subtitle: {
  //     text: ''
  //   },

  //   yAxis: [
  //     {
  //     reversed: invertirEje,
  //     title: {
  //       text: 'Volumen',
  //     },
  //     labels: {
  //       format: '{value} m3'
  //     }
  //   }
  //   ],

  //   xAxis: {
  //     type: 'categories',
  //     // tickWidth: 0,
  //     // gridLineWidth: 1,
  //     labels: {
  //       enabled: true,
  //       visible: true,
  //       step: 1,
  //       align: 'left',
  //       verticalAlign: 'bottom',
  //       // x: 3,
  //       // y: -3
  //     },

  //     // categories: DatosGra['Fecha'],
  //     // accessibility: {
  //     //     rangeDescription: 'Range: 2010 to 2017'
  //     //   }
  //   },

  //   legend: {
  //     layout: 'horizontal',
  //     align: 'center',
  //     verticalAlign: 'bottom'
  //   },
  //   tooltip: {
  //     shared: true,
  //     crosshairs: true
  //   },
  //   // plotOptions: {
  //   //     series: {
  //   //         label: {
  //   //             connectorAllowed: true
  //   //         },
  //   //         // pointStart: DatosFecha[0]
  //   //     }
  //   // },

  //   series: [
  //     {
  //     lineWidth: 0.5,
  //     yAxis: 0,
  //     name: 'Volumen',
  //     data: DataGraph
  //     }
  //   ],

  //   responsive: {
  //     rules: [{
  //       condition: {
  //         maxWidth: 500
  //       },
  //       chartOptions: {
  //         legend: {
  //           layout: 'horizontal',
  //           align: 'center',
  //           verticalAlign: 'bottom'
  //         }
  //       }
  //     }]
  //   }

  // });
}

async function updateSingleGraph(option) {

  const startDate = getDateFromOption(option);
  let myHeaders = new Headers();
  myHeaders.append('Content-Type', 'application/json');
  const parametros = {
    method: 'post',
    headers: myHeaders,
    body: JSON.stringify({ "endpoint": 'get_ac_single', "station": CurrentStation, "option": option, "startDate": startDate }),
    cache: 'no-cache',
    mode: 'cors',
    cache: 'default'
  };




  data = await obtenerJson(URLacu, parametros);
  updateDateFromOption(option, data);

}

async function updateDateFromOption(option, data) {
  DataGraphGeneral = [];

  const months = ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'];
  const categories = data.map((element) => { return element.date })

  switch (option) {
    case 'month':
      data.forEach((data) => {
        DataGraphGeneral.push({
          name: 'Dia ' + data.date,
          y: parseFloat(Number(data.acu).toFixed(2)),
          color: '#2196F3',
        });

      })

      buildGraph(DataGraphGeneral, 'daily', categories);
      break;
    case 'annual':
      data.forEach((data) => {
        DataGraphGeneral.push({
          name: months[Number(data.date) - 1],
          y: parseFloat(Number(data.acu).toFixed(2)),
          color: '#3F51B5',
        });;
      })
      const categoriesMonth = data.map((month) => { return months[Number(month.date) - 1] });
      buildGraph(DataGraphGeneral, 'monthly', categoriesMonth);

      break;

    default:
      data.forEach((data) => {
        DataGraphGeneral.push({
          name: 'Dia ' + data.date,
          y: parseFloat(Number(data.acu).toFixed(2)),
          color: '#2196F3',
        });

      })

      buildGraph(DataGraphGeneral, 'daily', categories);
      break;
  }




}

function getDateFromOption(option) {

  let date = '';
  switch (option) {
    case 'month':
      const month = document.getElementById('select_mes').value;
      const year = document.getElementById('select_mes_anual').value;

      date = year + "-" + month + "-01 00:00:00"
      break;
    case 'annual':
      const year2 = document.getElementById('select_anual').value;
      date = year2 + "-01-01 00:00:00"
      break;

    default:
      const month2 = document.getElementById('select_mes').value;
      const year3 = document.getElementById('select_mes_anual').value;

      date = year3 + "-" + month2 + "-01 00:00:00"
      break;
  }

  return date;
}

async function updateGraph(DatosGraAlturaPrevious, DatosGraCaudalPrevious, start, end, offset, limit, total) {

  if (offset >= total) {
    return;
  }


  const data = await getDataByQuery2(CurrentStation, start, end, offset, limit);

  const dataGraph = await getDataGrafica(data.data);

  const alt = DatosGraAlturaPrevious.concat(dataGraph.DatosGraAlturaNew);
  const caudal = DatosGraCaudalPrevious.concat(dataGraph.DatosGraCaudalNew);
  graphData.xAxis[0].setExtremes()
  graphData.update({
    series: [
      {
        yAxis: 0,
        data: alt
      },
      {
        yAxis: 1,
        data: caudal
      }
    ],
  });

  if (data.total > (offset + limit)) {
    await updateGraph(alt, caudal, start, end, (offset + limit), limit, data.total);
  }


}

function addZero(i) {
  if (i < 10) {
    i = "0" + i;
  }
  return i;
}

function zeroPadded(val) {
  if (val >= 10)
    return val;
  else
    return '0' + val;
}

async function showOrgStations(Org) {


  let file = new Array();

  let myHeaders = new Headers();
  myHeaders.append('Content-Type', 'application/json');
  const parametros = {
    method: 'post',
    headers: myHeaders,
    body: JSON.stringify({ "endpoint": 5, "organizacion": Org }),
    cache: 'no-cache',
    mode: 'cors',
    cache: 'default'
  };

  tablaToShow.splice(0);

  file = await obtenerJson(URLall, parametros);
  tablaToShow = await jsonToArray(file.items);


  var claves = [];
  //con Object.keys(array) obtenemos las claves del objeto
  claves = Object.keys(file.items[0]);
  tablaToShow.unshift(claves);
  agregarLinkestaciones(tablaToShow, 'ListaEstaciones');
  //agregarLinkestacionesParam(tablaToShow, 'ListaEstacionesParam');
}

function agregarLinkestaciones(arrayfile, idContainer) {
  // *********************


  Ncolumna = arrayfile[0].length;  // cuenta los elementos
  Nfila = arrayfile.length;      // cuenta la cantidad de registro


  // Obtener la referencia del elemento contenedor
  var body = document.getElementById(idContainer);


  var ul = document.createElement("ul");
  ul.id = "ulEstaciones";
  ul.style = "left: -25px; position: relative;"



  for (var i = 1; i < Nfila; i++) {

    var li = document.createElement("li");
    li.className = "nav-item";
    li.style = "height: fit-content; padding-top: 5px; padding-bottom: 5px; color:white;"
    var a = document.createElement("a");
    a.className = "nav-link";
    a.href = "#";
    a.textContent = arrayfile[i][1];
    li.appendChild(a);
    li.setAttribute("onclick", "verEstacion('" + arrayfile[i][0] + "')");
    ul.appendChild(li);

  }


  body.appendChild(ul);

  // *********************
}

async function infoUsers(user) {

  let myHeaders = new Headers();
  myHeaders.append('Content-Type', 'application/json');
  const parametros = {
    method: 'post',
    headers: myHeaders,
    body: JSON.stringify({ "endpoint": 7, "usuario": user }),
    cache: 'no-cache',
    mode: 'cors',
    cache: 'default'
  };


  usuario.splice(0);
  usuario = await obtenerJson(URLall, parametros);
  document.getElementById("userName").innerHTML = usuario.items[0].Nombre;
  organizacion = usuario.items[0].organizacion;
}

async function iniciar() {
  // setSelects();
  UpdateDateTime();
  CurrentStation = estacionMostrar;
  await obtenerStation(CurrentStation);
  setVariableOptions(DatosEstacion.Tipo)
  document.getElementById('stationname').innerHTML = DatosEstacion.Nombre;
  await infoUsers(usuarioActual);
  await showOrgStations(organizacion);
  // getAcuToGraph(CurrentStation);
}

async function setSelects() {

  const currentDate = new Date();
  const categoriesMonth = ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'];


  let selectMonth = document.getElementById('select_mes');

  categoriesMonth.forEach((mes, index) => {
    const option = document.createElement('option');

    option.value = index + 1;
    option.text = mes;

    if (index == currentDate.getMonth()) {
      option.selected = true;
    }

    selectMonth.appendChild(option)
  });


  let selectMesAnnual = document.getElementById('select_mes_anual');
  let selectAnnual = document.getElementById('select_anual');


  let year = 2000;

  for (let index = year; index < currentDate.getFullYear() + 1; index++) {
    const option = document.createElement('option');
    const option2 = document.createElement('option');

    option.value = index;
    option.text = index;
    option2.value = index;
    option2.text = index;

    if (index == currentDate.getFullYear()) {
      option.selected = true;
      option2.selected = true;
    }

    selectMesAnnual.appendChild(option);
    selectAnnual.appendChild(option2);

  }



}

async function verEstacion(estacion) {

  await SetGlobals({ 'view': 'views/detailStation.php', 'estacion': estacion });
  location.reload();

}

async function SetNewView(view) {
  let myHeaders = new Headers();
  myHeaders.append('Content-Type', 'application/json');
  const parametros = {
    method: 'post',
    headers: myHeaders,
    body: JSON.stringify({ "endpoint": 13, "view": view }),
    cache: 'no-cache',
    mode: 'cors',
    cache: 'default'
  };

  var respuesta = await obtenerJson(URLall, parametros);
}

async function SetGlobals(variables) {

  let myHeaders = new Headers();
  myHeaders.append('Content-Type', 'application/json');
  const parametros = {
    method: 'post',
    headers: myHeaders,
    body: JSON.stringify({ "endpoint": 14, "variables": variables }),
    cache: 'no-cache',
    mode: 'cors',
    cache: 'default'
  };

  var respuesta = await obtenerJson(URLall, parametros);
}

function zeroPadded(val) {
  var zero = "a"
  zero = "0"
  if (val >= 10)
    return val;
  else
    return zero + val;
}

function agregarLinkestacionesParam(arrayfile, idContainer) {
  // *********************
  Ncolumna = arrayfile[0].length;  // cuenta los elementos del headers
  Nfila = arrayfile.length;      // cuenta la cantidad de registro

  // Obtener la referencia del elemento contenedor
  var body = document.getElementById(idContainer);

  var ul = document.createElement("ul");
  ul.id = "ulEstaciones";
  ul.style = "left: -25px; position: relative;"

  for (var i = 1; i < Nfila; i++) {

    var li = document.createElement("li");
    li.className = "nav-item";
    li.style = "height: fit-content; padding-top: 5px; padding-bottom: 5px; color:white;"
    var a = document.createElement("a");
    a.className = "nav-link";
    a.href = "#";
    a.textContent = arrayfile[i][1];
    li.appendChild(a);
    li.setAttribute("onclick", "irEstacionParam('" + arrayfile[i][0] + "')");
    ul.appendChild(li);

  }


  body.appendChild(ul);

  // *********************
}

async function irEstacionParam(idStation) {
  await SetGlobals({ 'view': 'views/paramStation.php', 'estacion': idStation });
  location.reload();
}

async function view(view) {

  await SetGlobals({ 'view': 'views/' + view });
  location.reload();

}

function getFechaHora() {
  let date = new Date();
  let fecha = date.getFullYear() + '-' + zeroPadded((date.getMonth() + 1)) + '-' + zeroPadded(date.getDate());
  let hora = zeroPadded(date.getHours()) + ':' + zeroPadded(date.getMinutes()) + ':' + zeroPadded(date.getSeconds());

  return fecha + " " + hora;
}

function graphPush(total, estacion, inicio, fin, from, limit, graphPUSH, ghold) {

  let pages = pagesCant(total, limit) - 1
  console.log(pages)
  console.log(total)
  console.log(limit)
  let hold = "hold"
  let FROM = 2;
  for (let i = 0; i < pages; i++) {
    consultaVarOfStationDate(estacion, inicio, fin, FROM * limit, limit, 1, hold)
    FROM = FROM + 1
  }

}

function addVariable() {


  const variableContainer = document.getElementById('variableContainer')
  const resolution = document.getElementById('select_resolution').value;
  const variable = document.getElementById('add_variable').value;
  const medida = document.getElementById('add_medida').value;

  const newVar = createNewVariable(variable, medida);
  variableContainer.appendChild(newVar);
  Actualizar();

}

function createNewVariable(variableTxt, medidaTxt) {



  const prefix = 'variables_';
  const labelClass = "form-label col-4 d-flex justify-content-md-center align-items-center vh-100";
  const mainDiv = document.createElement('div');
  const variable = document.createElement('label');
  const medida = document.createElement('label');
  const deleteDiv = document.createElement('div');
  const deleteButton = document.createElement('button');
  const deleteIcon = document.createElement('icon');
  const getNumberId = getNewId();


  variable.textContent = getNameVariable(variableTxt);
  medida.textContent = medidaTxt;

  variable.for = "add_button";
  medida.for = "add_button"

  mainDiv.className = "d-flex row col-12";
  mainDiv.setAttribute('name', 'variableDynamicContainer');
  mainDiv.id = prefix + getNumberId;
  variable.className = labelClass;
  medida.className = labelClass;
  deleteDiv.className = "col-4 pt-1 pb-1";
  deleteButton.className = "btn btn-danger rounded-50";
  deleteButton.setAttribute('onclick', 'deleteVariable("' + mainDiv.id + '")');
  deleteIcon.className = "fa fa-trash";




  deleteButton.appendChild(deleteIcon);
  deleteDiv.appendChild(deleteButton);

  mainDiv.appendChild(variable);
  mainDiv.appendChild(medida);
  mainDiv.appendChild(deleteDiv);


  variables.push({
    id: mainDiv.id,
    variable: variableTxt,
    medida: medidaTxt
  });

  return mainDiv;







}

function deleteVariable(id) {

  const variableContainer = document.getElementById('variableContainer');

  const elementToDelete = document.getElementById(id);

  variableContainer.removeChild(elementToDelete)
  const index = variables.findIndex((vari) => {
    return (vari.id == id);
  })
  variables.splice(index, 1);
  Actualizar();
}

function getNewId() {
  const prefix = 'variables_';
  const elementsVariables = [...document.getElementsByName('variableDynamicContainer')];

  if (elementsVariables.length == 0) {
    return 0;
  }




  const ids = elementsVariables.map((element) => {
    return element.id
  });

  let newIdNumber = ids.length;

  do {
    newIdNumber++;
  } while (ids.includes(prefix + newIdNumber));


  return newIdNumber;



}

function setVariableOptions(stationType) {

  const variables = StationTypeConfiguration[stationType];
  const selectVariable = document.getElementById('add_variable')
  variables.forEach((variable) => {
    const option = document.createElement('option');
    option.value = variable.value;
    option.textContent = variable.name;

    selectVariable.appendChild(option)
  });

}

function getNameVariable(value) {

  const Names = StationTypeConfiguration[DatosEstacion.Tipo].filter((vari) => {
    return (vari.value == value);
  })

  return Names[0].name;


}

function getUnitVariable(value) {

  const Names = StationTypeConfiguration[DatosEstacion.Tipo].filter((vari) => {
    return (vari.value == value);
  })

  return Names[0].unit;


}

const StationTypeConfiguration = {
  1: [
    {
      name: "Nivel de agua",
      value: "altmm",
      unit: "cm"
    },
    {
      name: "Caudal",
      value: "flow",
      unit: "l/s"
    },
    {
      name: "Volumen",
      value: "volume",
      unit: "m3"
    }
  ],
  2: [
    {
      name: "Nivel freático",
      value: "altmm",
      unit: "m"
    },
    {
      name: "Caudal",
      value: "flow",
      unit: "l/s"
    },
    {
      name: "Volumen",
      value: "volume",
      unit: "m3"
    },
    {
      name: "Acumulado",
      value: "accumulated",
      unit: "m3"
    }
  ],
  3: [
    {
      name: "Nivel de agua",
      value: "altmm",
      unit: "cm"
    },
    {
      name: "Caudal",
      value: "flow",
      unit: "l/s"
    },
    {
      name: "Volumen",
      value: "volume",
      unit: "m3"
    },
  ],
  4: [
    {
      name: "Nivel de agua",
      value: "altmm",
      unit: "m"
    },
    {
      name: "Volumen",
      value: "volume",
      unit: "m3"
    },
  ],
  5: [
    {
      name: "Potencial de Hidrógeno",
      value: "flow",
      unit: "pH"
    },
    {
      name: "Conductividad eléctrica",
      value: "altmm",
      unit: "uS/cm"
    },
  ],
  6: [
    {
      name: "Nivel de agua",
      value: "altmm",
      unit: "cm"
    },
    {
      name: "Caudal",
      value: "flow",
      unit: "l/s"
    },
    {
      name: "Volumen",
      value: "volume",
      unit: "m3"
    }
  ],
}

function UpdateDateTime() {

  d = new Date();

  fecha = d.getFullYear() + "-" + zeroPadded(d.getMonth() + 1) + "-" + zeroPadded(d.getDate()) + "T" + zeroPadded(d.getHours()) + ":" + zeroPadded(d.getMinutes()) + ":" + zeroPadded(d.getSeconds());
  document.getElementById('date-time2').setAttribute("value", fecha);
  d.setDate(d.getDate() - 1);
  fecha = d.getFullYear() + "-" + zeroPadded(d.getMonth() + 1) + "-" + zeroPadded(d.getDate()) + "T" + zeroPadded(d.getHours()) + ":" + zeroPadded(d.getMinutes()) + ":" + zeroPadded(d.getSeconds());
  document.getElementById('date-time1').setAttribute("value", fecha);
}

async function Actualizar() {
  let station = CurrentStation;
  const { inicio, fin } = getDateRange();
  const resolution = document.getElementById('select_resolution').value
  let myHeaders = new Headers();
  myHeaders.append('Content-Type', 'application/json');
  const parametros = {
    method: 'post',
    headers: myHeaders,
    body: JSON.stringify({
      "endpoint": 'statistics',
      "station": String(station),
      "startDate": inicio,
      "endDate": fin,
      "variables": variables,
      'resolution': resolution,
      'stationType': String(DatosEstacion.Tipo),
    }),

    cache: 'no-cache',
    mode: 'cors',
    cache: 'default'
  };

  if (variables.length == 0) {
    document.getElementById('container').innerHTML = "";
    document.getElementById('containertable').innerHTML = "";
    return;
  }
  let respuesta = await obtenerJson(URLstatistics, parametros);

  const array = await jsonToArray(respuesta);

  const keys = Object.keys(respuesta[0]);

  const newKeys = [];

  const units = []
  keys.forEach((key) => {

    if (key !== 'Fecha') {
      // const sentence=key.replace("_"," ");
      const sentenceArray = key.split("_");
      units.push(getUnitVariable(sentenceArray[1]))
      sentenceArray[1] = getNameVariable(sentenceArray[1])

      // newKeys.push(capitalizeSentence(sentence));
      newKeys.push(capitalizeSentence(sentenceArray.join(" ")));

    } else {
      newKeys.push(capitalizeSentence(key));
    }

  })
  array.unshift(newKeys);

  const resolutionFormat = getDateFormatByResolution(resolution);

  let arrayTable = [];

  array.forEach((row, arrayIndex) => {

    let newRow = [];

    if (arrayIndex > 0) {

      row.forEach((variable, rowIndex) => {

        let newVariable;

        if (rowIndex > 0) {

          newVariable = Number(variable).toLocaleString('de-DE', { maximumFractionDigits: 2 });
          variable = Number(variable).toFixed(2);

          row[rowIndex] = variable;
          array[arrayIndex] = row;

          newRow.push(newVariable);
          arrayTable.push(newRow);

        } else {
          newRow.push(variable);
        }


      });
    } else {
      arrayTable.push(row);
    }




  });


  grafica('container', array, units, 0, 1, 'line', resolutionFormat);
  Array2D_to_tablaHTML_Paginator(arrayTable, 10, 1, 'containertable');
}

function getDateFormatByResolution(resolution) {

  let format = ""
  switch (resolution) {
    case "hora":
      format = "%Y-%m-%d %H";
      break
    case "dia":
      format = "%Y-%m-%d";
      break
    case "semana":
      format = "%Y-%m-%d";
      break
    case "mes":
      format = "%Y-%m";
      break
    case "semestre":
      format = "%Y-%m";
      break
    case "%Y":
      format = "";
      break
    default:
      format = "%Y-%m-%d %H";
      break;
  }


  return format;
}

function addVariableChange(_this) {

  document.getElementById('optionAcumulado').disabled = (_this.value !== 'volume')

  if (_this.value !== 'volume') {
    document.getElementById('optionAcumulado').selected = false;
  }

}

function getDateRange() {
  var inicio1 = new Date(document.getElementById('date-time1').value);
  var fin1 = new Date(document.getElementById('date-time2').value);
  var inicio = inicio1.getFullYear() + "-" + addZero((inicio1.getMonth() + 1)) + "-" + addZero(inicio1.getDate()) + " " + addZero(inicio1.getHours()) + ":00:00";
  var fin = fin1.getFullYear() + "-" + (addZero(fin1.getMonth() + 1)) + "-" + addZero(fin1.getDate()) + " " + addZero(fin1.getHours() - 1) + ":59:59";
  let objDate = {
    inicio, fin
  }
  return objDate
}

function capitalizeWord(word) {
  const lower = word.toLowerCase();
  return word.charAt(0).toUpperCase() + lower.slice(1);
}

function capitalizeSentence(sentence) {

  const words = sentence.split(" ");
  const newWords = []
  words.forEach((word, index) => {
    newWords.push(capitalizeWord(word));
  })

  sentence = newWords.join(" ");
  return sentence;

}

function setCurrentWeek() {
  var now = new Date();
  var first = now.getDate() - now.getDay() + (now.getDay() === 0 ? -6 : 1); // Ajustar al lunes
  var firstday = new Date(now.getFullYear(), now.getMonth(), first);

  var lastHour = new Date(now.getFullYear(), now.getMonth(), now.getDate(), now.getHours());

  document.getElementById('date-time1').value = formatDateToLocal(firstday);
  document.getElementById('date-time2').value = formatDateToLocal(lastHour);
}

function formatDateToLocal(date) {
  return `${date.getFullYear()}-${('0' + (date.getMonth() + 1)).slice(-2)}-${('0' + date.getDate()).slice(-2)}T${('0' + date.getHours()).slice(-2)}:${('0' + date.getMinutes()).slice(-2)}`;
}

function setCurrentMonth() {
  var now = new Date();
  var firstDay = new Date(now.getFullYear(), now.getMonth(), 1);
  var lastHour = new Date(now.getFullYear(), now.getMonth(), now.getDate(), now.getHours());

  document.getElementById('date-time1').value = formatDateToLocal(firstDay);
  document.getElementById('date-time2').value = formatDateToLocal(lastHour);
}

function setCurrentYear() {
  var now = new Date();
  var firstDay = new Date(now.getFullYear(), 0, 1);
  var lastHour = new Date(now.getFullYear(), now.getMonth(), now.getDate(), now.getHours());

  document.getElementById('date-time1').value = formatDateToLocal(firstDay);
  document.getElementById('date-time2').value = formatDateToLocal(lastHour);
}

const variables = [];
iniciar();
