<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>api docs</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" integrity="sha384-JcKb8q3iqJ61gNV9KGb8thSsNjpSL0n8PARn9HuZOnIxN0hoP+VmmDGMN5t9UJ0Z" crossorigin="anonymous">
    <link rel="stylesheet" href="../styles/apiDoc.css">
</head>
<body>

<section class="d-flex flex-column justify-content-center align-items-center">

<div class="titulo">API Monitoreo Hidrico</div>
<br>
<div class="subtitulo1">Introduccion</div>
<p class="parrafo">
La API Monitoreo Hidrico ha sido diseñada para obtener los datos correspondientes al monitoreo hidrico de estaciones superficiales y subterraneas, y para ser ocupada lo mas practico posible, es por ello que para acceder a los distintos datos de la plataforma utilizamos endpoints para cada requirimiento del cliente web.
</p><br>
<br>
<div class="subtitulo2">Parametros basicos</div>
<br>

<table class="table table-striped table-bordered">
    <thead>
        <tr>
            <th>Parametro</th>
            <th>Valor</th>
            <th>Descripcion</th>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td>url</td>
            <td>http://api.monitoreohidrico.cl/client.php</td>
            <td>url para las peticiones</td>
        </tr>
        <tr>
            <td> token</td>
            <td>xxxxxxxxxxxxxxxxxxxxxxxxxxxxxx</td>
            <td>codigo secreto alfanumerico de 30 digitos</td>
        </tr>
        <tr>
            <td>estacion</td>
            <td>xxxxxxxx</td>
            <td>codigo alfanumerico de la estacion</td>
        </tr>
        <tr>
            <td>endpoint</td>
            <td>NN</td>
            <td>codigo para seleccionar el tipo de consulta</td>
        </tr>
    </tbody>
</table><br>
<br>

<div class="subtitulo2">Descripcion de endpoints</div>
<br>

<table class="table table-striped table-bordered">
    <thead>
        <tr>
            <th>endpoint</th>
            <th>Descripcion</th>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td>0</td>
            <td>Obtener Vista</td>
        </tr>
        <tr>
            <td>1</td>
            <td>Obtener datos de estacion en un rango de fechas</td>
        </tr>
        <tr>
            <td>2</td>
            <td>Obtener todos los datos de una estacion</td>
        </tr>
        <tr>
            <td>3</td>
            <td>Obtener los promedios y acumulados de una estacion</td>
        </tr>
    </tbody>
</table><br>
<br>


<div class="subtitulo2">Parametros de Respuesta</div>
<br>
<table  class="table table-striped table-bordered">
 <thead>
        <tr>
            <th>Parametros</th>
            <th>Description</th>
            <th>Unidad</th>
            <th>Formato?</th>
            <th>Observación</th>
        </tr>
  </thead>
  <tbody>
  <tr>
            <td>Fecha</td>
            <td>Fecha de la medición</td>
            <td>-</td>
            <td>String</td>
            <td>-</td>
</tr>
<tr>
            <td>Nivel de agua</td>
            <td>Nivel de agua superficial</td>
            <td>Centimetros</td>
            <td>-</td>
            <td>*solo aguas superficiales</td>
</tr>
<tr>
            <td>Nivel freatico</td>
            <td>Nivel de agua subterráneas</td>
            <td>Metros</td>
            <td>-</td>
            <td>*solo aguas subterraneas</td>
</tr>
<tr>
            <td>Caudal</td>
            <td>Caudal del flujo de agua</td>
            <td>Litros por segundo</td>
            <td>-</td>
            <td>-</td>
</tr>
<tr>
            <td>Volumen</td>
            <td>Volumen de agua</td>
            <td>Metros cubicos</td>
            <td>-</td>
            <td>-</td>
</tr>
<tr>
            <td>promedioAño</td>
            <td>Volumen promedio anual</td>
            <td>Metros cubicos</td>
            <td>-</td>
            <td>-</td>
</tr>
<tr>
            <td>promedioSemestre</td>
            <td>Volumen promedio semestral</td>
            <td>Metros cubicos</td>
            <td>-</td>
            <td>-</td>
</tr>
<tr>
            <td>promedioMes</td>
            <td>Volumen promedio mensual</td>
            <td>Metros cubicos</td>
            <td>-</td>
            <td>-</td>
</tr>
<tr>
            <td>promedioDia</td>
            <td>Volumen promedio diario</td>
            <td>Metros cubicos</td>
            <td>-</td>
            <td>-</td>
</tr>
<tr>
            <td>AcumuladoAño</td>
            <td>Volumen acumulado anual</td>
            <td>Metros cubicos</td>
            <td>-</td>
            <td>-</td>
</tr>
<tr>
            <td>AcumuladoSemestre</td>
            <td>Volumen acumulado semestral</td>
            <td>Metros cubicos</td>
            <td>-</td>
            <td>-</td>
</tr>
<tr>
            <td>AcumuladoMes</td>
            <td>Volumen acumulado mensual</td>
            <td>Metros cubicos</td>
            <td>-</td>
            <td>-</td>
</tr>
<tr>
            <td>AcumuladoDia</td>
            <td>Volumen acumulado diario</td>
            <td>Metros cubicos</td>
            <td>-</td>
            <td>-</td>
</tr>
  </tbody>
</table>


<br>
<div class="subtitulo1">Obtener vista</div>
<div class="subtitulo2">HTML</div>
<div class="parrafo">•	Se deben agregar según sus preferencias los div con los id donde se mostrará el contenido:</div>
<div class="codigo">
&lt;div id="stationname"&gt; &lt;/div&gt;<br>
&lt;div id="contenido"&gt; &lt;/div&gt;
</div>
<div class="parrafo">•	Se deben ocupar las librerías de jquery mayor o igual a la versión 3.3.1 deferidas (defer).</div>
<div class="codigo">
&lt;script src="jquery/jquery-3.3.1.min.js" defer&gt;&lt;/script&gt;
</div>
<div class="subtitulo2">Script para cargar la vista</div>
<div class="parrafo">En el Script siguiente se ocupan peticiones POST a la siguiente URL:</div>
<div class="urlalerta">url: 'http://api.monitoreohidrico.cl/client.php'</div>
<div class="subtitulo2">Parametros para cargar vista</div>
<table class="table table-striped table-bordered">
    <thead>
        <tr>
            <th>Parametro</th>
            <th>Valor</th>
            <th>Descripcion</th>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td>url</td>
            <td>http://api.monitoreohidrico.cl/client.php</td>
            <td>url para las peticiones</td>
        </tr>
        <tr>
            <td>token</td>
            <td>xxxxxxxxxxxxxxxxxxxxxxxxxxxxxx</td>
            <td>codigo secreto alfanumerico de 30 digitos</td>
        </tr>
        <tr>
            <td>estacion</td>
            <td>xxxxxxxx</td>
            <td>codigo alfanumerico de la estacion</td>
        </tr>
        <tr>
            <td>endpoint</td>
            <td>0</td>
            <td>codigo para cargar la vista</td>
        </tr>
    </tbody>
</table><br>
<br>
<div class="parrafo">Utilizando Api FETCH en combinacion con JQuery AJAX se carga la vista:<br> Ejemplo: <br> </div>

<div class="codigo"> 
<br>
let token="55CMzzZp1dTpL1VKwhpZK6Cuubwau8";  <br>
let estacion="3";<br>
let endpoint=0;<br>
<br>
async function obtenerVista() <br>
{<br>
   $("#contenido").empty();<br>
   $("#stationname").empty();<br>
   <br>
    let url= 'http://api.monitoreohidrico.cl/client.php'<br>
    let myHeaders = new Headers();<br>
    myHeaders.append('Content-Type', 'application/json');<br>
    const parametros = <br>
    {<br>
      method: 'post',<br>
      redirect: 'follow',<br>
      headers: myHeaders,<br>
      body: JSON.stringify({"endpoint": endpoint ,"token":token ,"estacion": estacion, }),<br>
      cache: 'no-cache',<br>
      mode: 'cors',<br>
      cache: 'default'<br>
    };<br>
    <br>
  await  fetch (url2,parametros) <br>
    .then (response => {<br>
      console.log(response)<br>
    if(response.redirected){<br>
      $(document).ready(function() {<br>
        $('#contenido').load(response.url);<br>
    });<br>
    }<br>
})}<br>
</div>

<div class="subtitulo2">Respuesta:</div>
<div class="subtitulo3">Ejemplo de vista obtenida</div>

<img class="imagen" src="../img/vistacliente.png" alt="">

<div class="subtitulo1">Obtener archivo JSON con datos en un rango de fechas.</div>
<div class="subtitulo2">Parametros para obtener archivo JSON con datos en un rango de fechas</div>
<table class="table table-striped table-bordered">
    <thead>
        <tr>
            <th>Parametro</th>
            <th>Valor</th>
            <th>Descripcion</th>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td>url</td>
            <td>http://api.monitoreohidrico.cl/client.php</td>
            <td>url para las peticiones</td>
        </tr>
        <tr>
            <td>token</td>
            <td>xxxxxxxxxxxxxxxxxxxxxxxxxxxxxx</td>
            <td>codigo secreto alfanumerico de 30 digitos</td>
        </tr>
        <tr>
            <td>estacion</td>
            <td>xxxxxxxx</td>
            <td>codigo alfanumerico de la estacion</td>
        </tr>
        <tr>
            <td>endpoint</td>
            <td>1</td>
            <td>endpoint para obtener json con datos en un rango de fechas</td>
        </tr>
        <tr>
            <td>inicio</td>
            <td>"2020-08-05T23:51:13"</td>
            <td>Fecha formato date-time del inicio del intervalo a consultar</td>
        </tr>
        <tr>
            <td>final</td>
            <td>"2020-08-05T23:51:13"</td>
            <td>Fecha formato date-time del final del intervalo a consultar</td>
        </tr>
    </tbody>
</table><br>
<br>
<div class="subtitulo2">Script para obtener Json:</div>
<div class="parrafo">En el siguiente Script se ocupan peticiones POST mediante FETCH <br> Ejemplo: <br> </div>
<div class="codigo"> 
<br>
let token="55CMzzZp1dTpL1VKwhpZK6Cuubwau8";<br>
let estacion=3;<br>
let endpoint=1;<br>
let inicio="2020-08-05T23:51:13";   <br>
let fin="2020-08-06T23:51:13";<br>
<br>
<br>
async function obtenerJsonEstacion() <br>
{<br>
    let url2= 'http://api.monitoreohidrico.cl/client.php'<br>
    let myHeaders = new Headers();<br>
    myHeaders.append('Content-Type', 'application/json');<br>
    const parametros = <br>
    {<br>
      method: 'post',<br>
      headers: myHeaders,<br>
      body: JSON.stringify({"endpoint": endpoint ,"token":token ,"estacion": estacion,"inicio": inicio, "fin": fin,  }),<br>
      cache: 'no-cache',<br>
      mode: 'cors',<br>
      cache: 'default'<br>
    };<br>
   await fetch (url2,parametros) <br>
    .then (response => response.json())<br>
    .then (response => {console.log(response)}) <br>
}<br>
</div>
<br>
<div class=subtitulo2> Ejemplo de Respuesta esperada</div>
<br>
<div class="respuesta">
0: {Fecha: "2020-08-06 23:51:00", Altura [m]: 29.953, Caudal [l/s]: 0, Volumen [l]: 0}<br>
1: {Fecha: "2020-08-06 23:48:00", Altura [m]: 30.002, Caudal [l/s]: 0, Volumen [l]: 0}<br>
2: {Fecha: "2020-08-06 23:45:00", Altura [m]: 29.951, Caudal [l/s]: 0, Volumen [l]: 0}<br>
3: {Fecha: "2020-08-06 23:42:00", Altura [m]: 30.015, Caudal [l/s]: 0, Volumen [l]: 0}<br>
4: {Fecha: "2020-08-06 23:39:00", Altura [m]: 29.991, Caudal [l/s]: 0, Volumen [l]: 0}<br>
5: {Fecha: "2020-08-06 23:36:00", Altura [m]: 30.014, Caudal [l/s]: 0, Volumen [l]: 0}<br>
6: {Fecha: "2020-08-06 23:33:00", Altura [m]: 30.037, Caudal [l/s]: 0, Volumen [l]: 0}<br>
7: {Fecha: "2020-08-06 23:30:00", Altura [m]: 29.971, Caudal [l/s]: 0, Volumen [l]: 0}<br>
8: {Fecha: "2020-08-06 23:27:00", Altura [m]: 29.958, Caudal [l/s]: 0, Volumen [l]: 0}<br>
9: {Fecha: "2020-08-06 23:24:00", Altura [m]: 29.986, Caudal [l/s]: 0, Volumen [l]: 0}<br>
10: {Fecha: "2020-08-06 23:21:00", Altura [m]: 29.997, Caudal [l/s]: 0, Volumen [l]: 0}<br>
11: {Fecha: "2020-08-06 23:18:00", Altura [m]: 29.987, Caudal [l/s]: 0, Volumen [l]: 0}<br>
12: {Fecha: "2020-08-06 23:15:00", Altura [m]: 29.951, Caudal [l/s]: 0, Volumen [l]: 0}<br>
13: {Fecha: "2020-08-06 23:12:00", Altura [m]: 30.006, Caudal [l/s]: 0, Volumen [l]: 0}<br>
14: {Fecha: "2020-08-06 23:09:00", Altura [m]: 29.994, Caudal [l/s]: 0, Volumen [l]: 0}<br>
15: {Fecha: "2020-08-06 23:06:00", Altura [m]: 29.991, Caudal [l/s]: 0, Volumen [l]: 0}<br>
16: {Fecha: "2020-08-06 23:03:00", Altura [m]: 30.007, Caudal [l/s]: 0, Volumen [l]: 0}<br>
17: {Fecha: "2020-08-06 23:00:00", Altura [m]: 29.976, Caudal [l/s]: 0, Volumen [l]: 0}<br>
18: {Fecha: "2020-08-06 22:57:00", Altura [m]: 30.036, Caudal [l/s]: 0, Volumen [l]: 0}<br>
19: {Fecha: "2020-08-06 22:54:00", Altura [m]: 30.065, Caudal [l/s]: 0, Volumen [l]: 0}<br>
20: {Fecha: "2020-08-06 22:51:00", Altura [m]: 30.054, Caudal [l/s]: 0, Volumen [l]: 0}<br>
<br>
<br>
<div class="subtitulo3">Imagen Consola:</div> <br>
<img src="../img/respDatoFechas.png" alt="">
</div>
<br>
<br>
<div class="subtitulo1">Obtener todos los datos de una estacion</div>
<div class="subtitulo2">Parametros para obtener todos los datos de una estacion</div>
<table class="table table-striped table-bordered">
    <thead>
        <tr>
            <th>Parametro</th>
            <th>Valor</th>
            <th>Descripcion</th>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td>url</td>
            <td>http://api.monitoreohidrico.cl/client.php</td>
            <td>url para las peticiones</td>
        </tr>
        <tr>
            <td>token</td>
            <td>xxxxxxxxxxxxxxxxxxxxxxxxxxxxxx</td>
            <td>codigo secreto alfanumerico de 30 digitos</td>
        </tr>
        <tr>
            <td>estacion</td>
            <td>xxxxxxxx</td>
            <td>codigo alfanumerico de la estacion</td>
        </tr>
        <tr>
            <td>endpoint</td>
            <td>2</td>
            <td>codigo para obtener todos los datos de una estacion</td>
        </tr>
    </tbody>
</table><br>
<br>
<div class="subtitulo2">Script para obtener Json:</div>
<div class="parrafo">En el siguiente Script se ocupan peticiones POST mediante FETCH <br> Ejemplo: <br> </div>
<div class="codigo"> 
<br>
let token="55CMzzZp1dTpL1VKwhpZK6Cuubwau8";<br>
let estacion=3;<br>
let endpoint=2;<br>
<br>
async function obtenerJsonEstacion() <br>
{<br>
    let url2= 'http://api.monitoreohidrico.cl/client.php'<br>
    let myHeaders = new Headers();<br>
    myHeaders.append('Content-Type', 'application/json');<br>
    const parametros = <br>
    {<br>
      method: 'post',<br>
      headers: myHeaders,<br>
      body: JSON.stringify({"endpoint": endpoint ,"token":token ,"estacion": estacion,}),<br>
      cache: 'no-cache',<br>
      mode: 'cors',<br>
      cache: 'default'<br>
    };<br>
   await fetch (url2,parametros) <br>
    .then (response => response.json())<br>
    .then (response => {console.log(response)}) <br>
}<br>

</div>

<br>
<div class=subtitulo2> Ejemplo de Respuesta esperada</div>
<br>
<div class="respuesta">
0: {Fecha: "2020-08-06 23:51:00", Altura [m]: 29.953, Caudal [l/s]: 0, Volumen [l]: 0}<br>
1: {Fecha: "2020-08-06 23:48:00", Altura [m]: 30.002, Caudal [l/s]: 0, Volumen [l]: 0}<br>
2: {Fecha: "2020-08-06 23:45:00", Altura [m]: 29.951, Caudal [l/s]: 0, Volumen [l]: 0}<br>
3: {Fecha: "2020-08-06 23:42:00", Altura [m]: 30.015, Caudal [l/s]: 0, Volumen [l]: 0}<br>
4: {Fecha: "2020-08-06 23:39:00", Altura [m]: 29.991, Caudal [l/s]: 0, Volumen [l]: 0}<br>
5: {Fecha: "2020-08-06 23:36:00", Altura [m]: 30.014, Caudal [l/s]: 0, Volumen [l]: 0}<br>
6: {Fecha: "2020-08-06 23:33:00", Altura [m]: 30.037, Caudal [l/s]: 0, Volumen [l]: 0}<br>
7: {Fecha: "2020-08-06 23:30:00", Altura [m]: 29.971, Caudal [l/s]: 0, Volumen [l]: 0}<br>
8: {Fecha: "2020-08-06 23:27:00", Altura [m]: 29.958, Caudal [l/s]: 0, Volumen [l]: 0}<br>
9: {Fecha: "2020-08-06 23:24:00", Altura [m]: 29.986, Caudal [l/s]: 0, Volumen [l]: 0}<br>
10: {Fecha: "2020-08-06 23:21:00", Altura [m]: 29.997, Caudal [l/s]: 0, Volumen [l]: 0}<br>
11: {Fecha: "2020-08-06 23:18:00", Altura [m]: 29.987, Caudal [l/s]: 0, Volumen [l]: 0}<br>
12: {Fecha: "2020-08-06 23:15:00", Altura [m]: 29.951, Caudal [l/s]: 0, Volumen [l]: 0}<br>
13: {Fecha: "2020-08-06 23:12:00", Altura [m]: 30.006, Caudal [l/s]: 0, Volumen [l]: 0}<br>
14: {Fecha: "2020-08-06 23:09:00", Altura [m]: 29.994, Caudal [l/s]: 0, Volumen [l]: 0}<br>
15: {Fecha: "2020-08-06 23:06:00", Altura [m]: 29.991, Caudal [l/s]: 0, Volumen [l]: 0}<br>
16: {Fecha: "2020-08-06 23:03:00", Altura [m]: 30.007, Caudal [l/s]: 0, Volumen [l]: 0}<br>
17: {Fecha: "2020-08-06 23:00:00", Altura [m]: 29.976, Caudal [l/s]: 0, Volumen [l]: 0}<br>
18: {Fecha: "2020-08-06 22:57:00", Altura [m]: 30.036, Caudal [l/s]: 0, Volumen [l]: 0}<br>
19: {Fecha: "2020-08-06 22:54:00", Altura [m]: 30.065, Caudal [l/s]: 0, Volumen [l]: 0}<br>
20: {Fecha: "2020-08-06 22:51:00", Altura [m]: 30.054, Caudal [l/s]: 0, Volumen [l]: 0}<br>
<br>
<br>
<div class="subtitulo3">Imagen Consola:</div> <br>
<img src="../img/respDatoTodos.png" alt="">
</div>
<br>


<br>
<div class="subtitulo1">Obtener promedios y acumulados de una estacion</div>
<div class="subtitulo2">Parametros para obtener promedios y acumulados de una estacion</div>
<table class="table table-striped table-bordered">
    <thead>
        <tr>
            <th>Parametro</th>
            <th>Valor</th>
            <th>Descripcion</th>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td>url</td>
            <td>http://api.monitoreohidrico.cl/client.php</td>
            <td>url para las peticiones</td>
        </tr>
        <tr>
            <td>token</td>
            <td>xxxxxxxxxxxxxxxxxxxxxxxxxxxxxx</td>
            <td>codigo secreto alfanumerico de 30 digitos</td>
        </tr>
        <tr>
            <td>estacion</td>
            <td>xxxxxxxx</td>
            <td>codigo alfanumerico de la estacion</td>
        </tr>
        <tr>
            <td>endpoint</td>
            <td>3</td>
            <td>codigo para obtener promedios y acumulados de una estacion</td>
        </tr>
    </tbody>
</table><br>
<br>
<div class="subtitulo2">Script para obtener Json:</div>
<div class="parrafo">En el siguiente Script se ocupan peticiones POST mediante FETCH <br> Ejemplo: <br> </div>
<div class="codigo"> 
<br>
let token="55CMzzZp1dTpL1VKwhpZK6Cuubwau8";<br>
let estacion=3;<br>
let endpoint=3;<br>
<br>
async function obtenerJsonEstacion() <br>
{<br>
    let url2= 'http://api.monitoreohidrico.cl/client.php'<br>
    let myHeaders = new Headers();<br>
    myHeaders.append('Content-Type', 'application/json');<br>
    const parametros = <br>
    {<br>
      method: 'post',<br>
      headers: myHeaders,<br>
      body: JSON.stringify({"endpoint": endpoint ,"token":token ,"estacion": estacion,}),<br>
      cache: 'no-cache',<br>
      mode: 'cors',<br>
      cache: 'default'<br>
    };<br>
   await fetch (url2,parametros) <br>
    .then (response => response.json())<br>
    .then (response => {console.log(response)}) <br>
}<br>
<br>
</div>
<br>

<div class=subtitulo2> Ejemplo de Respuesta esperada</div>
<div class="respuesta">
<br>
Acumulados: Array(1)
<br>&nbsp;0:
<br>&nbsp;&nbsp;AcumuladoAño: 752.5
<br>&nbsp;&nbsp;AcumuladoDia: 0
<br>&nbsp;&nbsp;AcumuladoMes: 127.4
<br>&nbsp;&nbsp;AcumuladoSemana: 0
<br>&nbsp;&nbsp;AcumuladoSemestre: 400.7
<br>
promedios: Array(1)
<br>&nbsp;0:
<br>&nbsp;&nbsp;promedioAño: 0
<br>&nbsp;&nbsp;promedioDia: 6.4316239316239
<br>&nbsp;&nbsp;promedioMes: 192.94871794872
<br>&nbsp;&nbsp;promedioSemana: 45.021367521367
<br>&nbsp;&nbsp;promedioSemestre: 0


<div class="subtitulo3">Imagen Consola:</div> <br>
<img src="../img/respPromyAcumu.png" alt="">
</div>
<br>



</section>


<script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js" integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN" crossorigin="anonymous"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js" integrity="sha384-B4gt1jrGC7Jh4AgTPSdUtOBvfO8shuf57BaghqFfPlYxofvL8/KUEfYiJOMMV+rV" crossorigin="anonymous"></script>
    
</body>
</html>