<?php
include_once '/home/wwhidr/monitoreohidrico.cl/Website/api/metrica.php';

class Dga
{

    public $id;
    public $codigoDeLaObra;
    public $timeStampOrigen;
    public $fechaMedicion;
    public $horaMedicion;
    public $id_station;
    public $data_json;
    public $respuesta;
    public $enviado;
    public $create_date_time;
    public $update_date_time;

    public function __construct($codigoDeLaObra, $datetime, $id_station)
    {
        $dga = $this::dga_data_exists($codigoDeLaObra, $datetime, $id_station);
        if ($dga != false) {
            $this->id = $dga->id;
            $this->codigoDeLaObra = $dga->codigoDeLaObra;
            $this->timeStampOrigen = $dga->timeStampOrigen;
            $this->fechaMedicion = $dga->date('Y-m-d', $datetime);
            $this->horaMedicion = $dga->date('G:i:s', $datetime);
            $this->id_station = $dga->$id_station;
            $this->data_json = $dga->data_json;
            $this->respuesta = $dga->respuesta;
            $this->enviado = $dga->enviado;
            $this->create_date_time = $dga->create_date_time;
            $this->update_date_time = $dga->update_date_time;
        } else {
            $this->codigoDeLaObra = $codigoDeLaObra;
            $this->timeStampOrigen = null;
            $this->fechaMedicion = date('Y-m-d', $datetime);
            $this->horaMedicion = date('H:i:s', $datetime);
            $this->id_station = $id_station;
            $this->data_json = null;
            $this->respuesta = 0;
            $this->enviado = 0;
        }
    }

    public static function dga_data_exists($codigoDeLaObra, $datetime, $id_station)
    {
        return false;
        $metrica =  new Metrica();
        $metricas = array();

        $res = $metrica->obtenerDGA($codigoDeLaObra, date('d-m-Y', $datetime), date('H:i:s', $datetime), $id_station);

        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                $item = array(
                    'id' => $row['id'],
                    'codigoDeLaObra' => $row['codigoDeLaObra'],
                    'timeStampOrigen' => $row['timeStampOrigen'],
                    'fechaMedicion' => $row['fechaMedicion'],
                    'horaMedicion' => $row['horaMedicion'],
                    'id_station' => $row['id_station'],
                    'data_json' => $row['data_json'],
                    'respuesta' => $row['respuesta'],
                    'recibido' => $row['recibido'],
                    'enviado' => $row['enviado'],
                    'create_date_time' => $row['create_date_time'],
                    'update_date_time' => $row['update_date_time'],
                );
                array_push($metricas, $item);
            }
            $respuesta = json_decode(json_encode($metricas[0]));
            return $respuesta;
        } else {
            return false;
        }
    }
    public static function get_dga_stations()
    {

        $metrica =  new Metrica();
        $metricas = array();
        $metricas["items"] = array();
        $res = $metrica->obtener_dga_stations();

        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                $item = array(
                    'id' => $row['idest'],
                    'Nombre' => $row['nombre'],
                    'Latitud' => $row['latitud'],
                    'Longitud' => $row['longitud'],
                    'Tipo' => $row['tipoestacionid'],
                    'A' => $row['A'],
                    'B' => $row['B'],
                    'Org' => $row['organizacion'],
                    'Tiempo' => $row['tiempo'],
                    'estado' => $row['estado'],
                    'nivel_corte' => $row['nivel_corte'],
                    'DGA_MEE' => $row['DGA_MEE'],
                    'codigoDeLaObra' => json_decode($row['codigoDeLaObra']),
                );
                array_push($metricas['items'], $item);
            }

            return $metricas;
        } else {
            return array('mensaje' => 'No hay elementos registrados');
        }
    }

    public static function get_dga_last_data_stations()
    {

        $metrica =  new Metrica();
        $metricas = array();
        $metricas["items"] = array();
        $res = $metrica->obtener_dga_last_data_stations();

        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                $item = array(
                    'id_station' => $row['id_station'],
                    'codigoDeLaObra' => $row['codigoDeLaObra'],
                    'fechaMedicion' => $row['fechaMedicion'],
                    'horaMedicion' => $row['horaMedicion'],
                    'fechaHora' => $row['fechaHora'],
                    'date' => substr($row['fechaMedicion'], 6, 4) . "-" . substr($row['fechaMedicion'], 3, 2) . "-" . substr($row['fechaMedicion'], 0, 2) . " " . $row['horaMedicion'],
                );
                array_push($metricas['items'], $item);
            }

            return $metricas;
        } else {
            return array('mensaje' => 'No hay elementos registrados');
        }
    }

    public static function get_stations_by_id($station_id)
    {

        $metrica =  new Metrica();
        $res = $metrica->obtenerInfoStation($station_id);

        if ($res->rowCount()) {
            $_station = $res->fetchObject();
            $station = new stdClass();
            $station->id = $_station->idest;
            $station->Nombre = $_station->nombre;
            $station->Latitud = $_station->latitud;
            $station->Longitud = $_station->longitud;
            $station->Tipo = $_station->tipoestacionid;
            $station->A = $_station->A;
            $station->B = $_station->B;
            $station->Org = $_station->organizacion;
            $station->Tiempo = $_station->tiempo;
            $station->estado = $_station->estado;
            $station->nivel_corte = $_station->nivel_corte;
            $station->DGA_MEE = $_station->DGA_MEE;
            $station->codigoDeLaObra = json_decode($_station->codigoDeLaObra);

            return $station;
        } else {
            return array('mensaje' => 'No hay elementos registrados');
        }
    }
    public function get_station_dga_format($estacion, $date)
    {

        $metrica =  new Metrica();
        $metricas = array();
        $metricas["items"] = array();
        $res = $metrica->obtenerStationByOneDate($estacion, $date);

        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                $item = array(
                    'fechaMedicion' => substr($row['date'], 0, 10),
                    'horaMedicion' => substr($row['date'], 11),
                    'totalizador' => $row['accumulated'],
                    'caudal' => $row['flow'],
                    'nivelFreaticoDelPozo' => $row['altmm'],
                );
                array_push($metricas['items'], $item);
            }

            return $metricas;
        } else {
            return array('mensaje' => 'No hay elementos registrados');
        }
    }
    public static function insert_dga_data($codigoDeLaObra, $fechaMedicion, $horaMedicion, $id_station)
    {
        return Metrica::insert_dga($codigoDeLaObra, $fechaMedicion, $horaMedicion, $id_station);
    }
    public static function update_dga_data($codigoDeLaObra, $timeStampOrigen, $fechaMedicion, $horaMedicion, $id_station, $data_json, $respuesta, $recibido, $enviado)
    {
        return  Metrica::update_dga($codigoDeLaObra, $timeStampOrigen, $fechaMedicion, $horaMedicion, $id_station, $data_json, $respuesta, $recibido, $enviado);
    }

    public static function get_dga_not_received()
    {

        $metrica =  new Metrica();
        $metricas = array();
        $res = $metrica->obtener_dga_not_received();

        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                $item = array(
                    'id' => $row['id'],
                    'codigoDeLaObra' => $row['codigoDeLaObra'],
                    'timeStampOrigen' => $row['timeStampOrigen'],
                    'fechaMedicion' => $row['fechaMedicion'],
                    'horaMedicion' => $row['horaMedicion'],
                    'id_station' => $row['id_station'],
                    'data_json' => $row['data_json'],
                    'respuesta' => $row['respuesta'],
                    'recibido' => $row['recibido'],
                    'enviado' => $row['enviado'],
                    'create_date_time' => $row['create_date_time'],
                    'update_date_time' => $row['update_date_time'],
                    'date' => substr($row['fechaMedicion'], 6, 4) . "-" . substr($row['fechaMedicion'], 3, 2) . "-" . substr($row['fechaMedicion'], 0, 2) . " " . $row['horaMedicion'],
                );
                array_push($metricas, $item);
            }

            return $metricas;
        } else {
            return array('mensaje' => 'No hay elementos registrados');
        }
    }
    public static function get_dga_not_sent()
    {

        $metrica =  new Metrica();
        $metricas = array();
        $res = $metrica->obtener_dga_not_sent();

        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                $item = array(
                    'id' => $row['id'],
                    'codigoDeLaObra' => $row['codigoDeLaObra'],
                    'timeStampOrigen' => $row['timeStampOrigen'],
                    'fechaMedicion' => $row['fechaMedicion'],
                    'horaMedicion' => $row['horaMedicion'],
                    'id_station' => $row['id_station'],
                    'data_json' => $row['data_json'],
                    'respuesta' => $row['respuesta'],
                    'recibido' => $row['recibido'],
                    'enviado' => $row['enviado'],
                    'create_date_time' => $row['create_date_time'],
                    'update_date_time' => $row['update_date_time'],
                    'date' => substr($row['fechaMedicion'], 6, 4) . "-" . substr($row['fechaMedicion'], 3, 2) . "-" . substr($row['fechaMedicion'], 0, 2) . " " . $row['horaMedicion'],
                );
                array_push($metricas, $item);
            }

            return $metricas;
        } else {
            return array('mensaje' => 'No hay elementos registrados');
        }
    }

    public static function is_dga_received($estacion, $date)
    {

        $metrica =  new Metrica();
        $metricas = array();
        $res = $metrica->obtenerStationByOneDate($estacion, $date);
        $info_est = $metrica->obtenerInfoStation($estacion);

        // Obtener tipoestacionid de $info_est
        $tipoestacionid = null;
        if ($info_est->rowCount()) {
            $info = $info_est->fetch(PDO::FETCH_ASSOC);
            $tipoestacionid = $info['tipoestacionid'];
        }

        if ($res->rowCount()) {
            while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
                if ($tipoestacionid == 2) {
                $item = array(
                    'date' => $row['date'],
                    'fechaMedicion' => substr($row['date'], 8, 2) . "-" . substr($row['date'], 5, 2) . "-" . substr($row['date'], 0, 4),
                    'horaMedicion' => substr($row['date'], 11),
                    'totalizador' => $row['accumulated'],
                    'caudal' => $row['flow'],
                    'nivelFreaticoDelPozo' => $row['altmm'],
                );
            }else{
                $item = array(
                    'date' => $row['date'],
                    'fechaMedicion' => substr($row['date'], 8, 2) . "-" . substr($row['date'], 5, 2) . "-" . substr($row['date'], 0, 4),
                    'horaMedicion' => substr($row['date'], 11),
                    'caudal' => $row['flow'],
                    'alturaLimnimetrica' => $row['altmm'],
                );

                }
                array_push($metricas, $item);
            }
            $respuesta = json_decode(json_encode($metricas[0]));
            return $respuesta;
        } else {
            return false;
        }
    }

    public static function sent_dga_data($codigoDeLaObra, $timeStampOrigen, $data_json, $type)
    {

        $fecha   = date('Y-m-d G:i:s');
        $codigodedato   = date('YmdGis');

        $fechaMedicion = $data_json->fechaMedicion;
        $horaMedicion = $data_json->horaMedicion;

        $headerVar = new SoapVar(
            '<aut1:authSendDataExtraccionTraza xmlns:aut1="http://www.mop.cl/controlextraccion/xsd/datosExtraccion/AuthSendDataExtraccionRequest"> <aut1:codigoDeLaObra>' . $codigoDeLaObra->codigoDeLaObra . '</aut1:codigoDeLaObra> <aut1:timeStampOrigen>' . $timeStampOrigen . '</aut1:timeStampOrigen> </aut1:authSendDataExtraccionTraza>',
            XSD_ANYXML
        );
       
        $totalizador = number_format($data_json->totalizador, 0, ".", "");
        $caudal = number_format($data_json->caudal, 2, ".", "");
        $nivelFreaticoDelPozo = number_format($data_json->nivelFreaticoDelPozo / 1000, 2, ".", "");    
        $request = new SoapVar(
            '<aut1:authSendDataExtraccionRequest xmlns:aut1="http://www.mop.cl/controlextraccion/xsd/datosExtraccion/AuthSendDataExtraccionRequest"> <aut1:authDataUsuario> <aut1:idUsuario> <aut1:rut>' . $codigoDeLaObra->rut . '</aut1:rut>
</aut1:idUsuario> <aut1:password>' . $codigoDeLaObra->password . '</aut1:password> </aut1:authDataUsuario> <aut1:authDataExtraccionSubterranea> <aut1:fechaMedicion>' . $fechaMedicion . '</aut1:fechaMedicion> <aut1:horaMedicion>' . $horaMedicion . '</aut1:horaMedicion> <aut1:totalizador>' . $totalizador . '</aut1:totalizador> <aut1:caudal>' . $caudal . '</aut1:caudal> <aut1:nivelFreaticoDelPozo>' . $nivelFreaticoDelPozo . '</aut1:nivelFreaticoDelPozo> </aut1:authDataExtraccionSubterranea> </aut1:authSendDataExtraccionRequest>',
            XSD_ANYXML
        );


        $header = new SoapHeader(
            'http://www.mop.cl/controlextraccion/xsd/datosExtraccion/AuthSendDataExtraccionService',
            'header',
            $headerVar
        );

        $client = new SoapClient('https://snia.mop.gob.cl/controlextraccion/wsdl/datosExtraccion/SendDataExtraccionService?wsdl');
        $client->__setSoapHeaders($header);



        // $result = $client->__call("sendDataExtraccionOp", array($xml));

        try {
            $result = $client->authSendDataExtraccionOp($request);
            print_r(json_encode($result));
        } catch (\Throwable $th) {
            print_r(json_encode($th));
        }


        $log = "{-----code_nro°:{" . $codigodedato . "}----Fecha: {" . $fecha . "} ------------------}\n ";
        $log .= "Datos enviados=>\n";
        $log .= "codigoDeLaObra:" . $codigoDeLaObra->codigoDeLaObra . "\n";
        $log .= "RUT:" . $codigoDeLaObra->rut . "\n";
        $log .= "password:" . $codigoDeLaObra->password . "\n";
        $log .= "timeStampOrigen:" . $timeStampOrigen . "\n";
        $log .= "fechaMedicion:" . $fechaMedicion . "\n";
        $log .= "horaMedicion:" . $horaMedicion . "\n";
        if ($type == 2) {
            $log .= "totalizador:" . $data_json->totalizador . "\n";
            $log .= "caudal:" . $data_json->caudal . "\n";
            $log .= "nivelFreaticoDelPozo:" . $data_json->nivelFreaticoDelPozo . "\n";
        } else {
            $log .= "caudal:" . $data_json->caudal . "\n";
            $log .= "alturaLimnimetrica:" . $data_json->alturaLimnimetrica . "\n";
        }
        $log .= "{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<___Respuesta___>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}\n";
        $log .= "Code: {" . $result->status->Code . "}\n";
        $log .= "Description: {" . $result->status->Description . "}\n";
        $log .= "{-----Final de dato:{" . $codigodedato . "}--------------------------------------}\n ";
        $log .= "----------------------------------------------------------------------------\n\n ";


        $file = fopen("dga.log", "a");
        fwrite($file, $log . PHP_EOL);
        fclose($file);

        return $result;
    }

    private function formatXml($simpleXMLElement)
    {
        $xmlDocument = new \DOMDocument('1.0');
        $xmlDocument->preserveWhiteSpace = false;
        $xmlDocument->formatOutput = true;
        $xmlDocument->loadXML($simpleXMLElement->asXML());
        return $xmlDocument->saveXML();
    }
}
