<?php

include_once 'dga_class.php';

$datetime_UTC = date('Y-m-d') . 'T' . date('H:i:s') . 'Z';
date_default_timezone_set('America/Santiago');
$fechaMedicion = date('Y-m-d');
$fechaMedicion_dga = date('d-m-Y');
$horaMedicion = date('H') . ':00:00';
$datetime_measure = $fechaMedicion . ' ' . $horaMedicion;
$dga_stations = Dga::get_dga_stations();


/////CHEQUEO DE HUECOS EN REGISTRO DE FIFO///////

$stations_last_data=Dga::get_dga_last_data_stations();
$horaActual = new DateTime();
foreach ($stations_last_data["items"] as $value) {
    $id_station = $value["id_station"];
    $fechaHora = new DateTime($value["fechaHora"]);
    $codigoDeLaObra =  $value["codigoDeLaObra"];
    $fechaSiguiente = clone $fechaHora;
    $fechaSiguiente->add(new DateInterval('PT1H')); // Agregar 1 hora
    $horaPrevia=$horaActual->sub(new DateInterval('PT1H'));
    while ($fechaSiguiente->format('Y-m-d H:i:s') < $horaPrevia->format('Y-m-d H:i:s')) {
        $fechaMedicion2 = $fechaSiguiente->format('d-m-Y');
        $horaMedicion2 = $fechaSiguiente->format('H:00:00');
        $fechaSiguiente->add(new DateInterval('PT1H')); // Agregar 1 hora
        Dga::insert_dga_data($codigoDeLaObra, $fechaMedicion2, $horaMedicion2, $id_station);
    }
}

/////INSERT DGA FIFO INICIAL///////

foreach ($dga_stations['items'] as $station) {
      $station_info = json_decode(json_encode($station));
      $codigoDeLaObra = $station_info->codigoDeLaObra->codigoDeLaObra;
      $id_station = $station_info->id;
      Dga::insert_dga_data($codigoDeLaObra, $fechaMedicion_dga, $horaMedicion, $id_station);
}


/////VERIFICA SI LLEGARON DGA FALTANTES Y ACTUALIZA DGA_DATOS///////

$dga_not_received = Dga::get_dga_not_received();
if (isset($dga_not_received['mensaje']) && $dga_not_received['mensaje'] == 'No hay elementos registrados') {
    exit('Lo sentimos, no pudimos encontrar los datos solicitados. Por favor, intente de nuevo más tarde.');
}

foreach ($dga_not_received as $dga) {
      $dga_n = json_decode(json_encode($dga));
      $dga_data = Dga::is_dga_received($dga_n->id_station, $dga_n->date);
      if ($dga_data != false) {
            Dga::update_dga_data($dga_n->codigoDeLaObra, null, $dga_n->fechaMedicion, $dga_n->horaMedicion, $dga_n->id_station, $dga_data, null, '1', null);
      }
}

/////EXTRAE LOS DGA NO ENVIADOS, LOS ENVIA Y ACTUALIZA DGA_DATOS///////

$dga_not_sent = Dga::get_dga_not_sent();

foreach ($dga_not_sent as $dga) {
      $dga_n = json_decode(json_encode($dga));
      $dga_data = Dga::is_dga_received($dga_n->id_station, $dga_n->date);
      if ($dga_data != false) {
            $station=Dga::get_stations_by_id($dga_n->id_station);
            $respuesta = Dga::sent_dga_data($station->codigoDeLaObra, $datetime_UTC, $dga_data, "1");

            if ($respuesta->status->Code == '0') {
                  $enviado = '1';
            } else {
                  $enviado = '0';
            }
            Dga::update_dga_data($dga_n->codigoDeLaObra, $datetime_UTC, $dga_n->fechaMedicion, $dga_n->horaMedicion, $dga_n->id_station, json_encode($dga_data), json_encode($respuesta), null, $enviado);
      }
}
